
/* START_TEMPLATE */
define('hbs!nmodule/honIrmControl/rc/templates/modbusDeviceView',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "<div class=\"main-container-modbus-view\">\n	<header class=\"title\">\n		<label id=\"deviceNameLabelId\"></label>  \n	</header>\n\n	<div class=\"device-prop-container\">\n		<div class=\"device-prop-wrapper\">\n			<div class=\"device-properties-1\" style=\"padding-left:2px\">\n			   <div class=\"form-wrapper\">\n				<label for=\"Device Address\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"DeviceAddress") || (depth0 != null ? lookupProperty(depth0,"DeviceAddress") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"DeviceAddress","hash":{},"data":data,"loc":{"start":{"line":10,"column":32},"end":{"line":10,"column":49}}}) : helper)))
    + "</label>\n				<div>\n				<input class=\"form-element form-element-text-left\" id=\"devAddressId\" type=\"number\" min=\"1\" max=\"247\" value=\"\"  />\n				<label for=\"Device address Range\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"DeviceAddressRange") || (depth0 != null ? lookupProperty(depth0,"DeviceAddressRange") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"DeviceAddressRange","hash":{},"data":data,"loc":{"start":{"line":13,"column":38},"end":{"line":13,"column":60}}}) : helper)))
    + "</label>\n				</div>\n				</div>			\n			</div>\n			<div class=\"device-properties-2\">\n				<div class=\"form-wrapper\">\n				<label for=\"Byte Order\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"ByteOrder") || (depth0 != null ? lookupProperty(depth0,"ByteOrder") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"ByteOrder","hash":{},"data":data,"loc":{"start":{"line":19,"column":28},"end":{"line":19,"column":41}}}) : helper)))
    + "</label>\n				<select id=\"byteOrderId\" class=\"form-element\" >\n				</select>\n				</div>\n			</div>	\n			<div class=\"device-properties-3\" >\n			   <div class=\"form-wrapper\">\n				<label for=\"Max Read Registers Count\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"MaxReadPointsCount") || (depth0 != null ? lookupProperty(depth0,"MaxReadPointsCount") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"MaxReadPointsCount","hash":{},"data":data,"loc":{"start":{"line":26,"column":42},"end":{"line":26,"column":64}}}) : helper)))
    + "</label>\n				<div>\n				<input id=\"maxReadPointsCountId\" class=\"form-element form-element-text-left\" type=\"number\" min=\"1\" max=\"20\" value=\"\" />\n				<label for=\"read point Range\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"MaxReadPointsCountRange") || (depth0 != null ? lookupProperty(depth0,"MaxReadPointsCountRange") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"MaxReadPointsCountRange","hash":{},"data":data,"loc":{"start":{"line":29,"column":34},"end":{"line":29,"column":61}}}) : helper)))
    + "</label>\n				</div>\n				</div>							\n		</div>	\n		</div>	\n\n    </div>\n	\n	<div class=\"tab-container\">	\n		<div class=\"modbus-tab\">\n		  <div class=\"button-cover\">\n		  <button class=\"tablinks active\" data-tabname=\"pointReadTabId\">Read Points</button>\n		  <button class=\"tablinks Inactive\" data-tabname=\"pointWriteTabId\">Write Points</button>\n		  </div>\n		</div>		\n			   \n		<div id=\"pointReadTabId\" class=\"tabcontent\">\n		<div class=\"button-container\">\n		  <div class=\"div-inline\">\n		  		<label for=\"Read Points Count\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"ReadPointsCount") || (depth0 != null ? lookupProperty(depth0,"ReadPointsCount") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"ReadPointsCount","hash":{},"data":data,"loc":{"start":{"line":48,"column":37},"end":{"line":48,"column":56}}}) : helper)))
    + "</label>\n		  		<label id=\"readPointCountId\"></label>\n				<!-- input class=\"form-element-small form-element-text-left\" id=\"readPointCountId\" type=\"text\" value=\"\" readonly /-->\n		  </div>\n		  <div class=\"div-inline\"><button class=\"common-button\" id =\"addButtonReadPointId\">Add</button></div>\n		  <div class=\"div-inline\"><button class=\"common-button\" id =\"deleteButtonReadPointId\">Delete</button></div>\n		</div>\n		\n		 <div class=\"modbus-comp-table\">		 \n			<div class=\"modbus-comp-table-header\">\n			  <div class=\"md-table-row\">\n			    <div class=\"modbus-comp-table-cell\" id =\"readPtNameCellId\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"ReadPointName") || (depth0 != null ? lookupProperty(depth0,"ReadPointName") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"ReadPointName","hash":{},"data":data,"loc":{"start":{"line":59,"column":66},"end":{"line":59,"column":83}}}) : helper)))
    + "<span id=\"sortReadPtNameIconId\"></span></div>\n				<div class=\"modbus-comp-table-cell\" id =\"readPtTypeCellId\" >"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"ReadPointType") || (depth0 != null ? lookupProperty(depth0,"ReadPointType") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"ReadPointType","hash":{},"data":data,"loc":{"start":{"line":60,"column":64},"end":{"line":60,"column":81}}}) : helper)))
    + "<span id=\"sortReadPtTypeIconId\"></span></div>				\n				<div class=\"modbus-comp-table-cell\" id =\"readPtAddressCellId\" >"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"ReadPointAddress") || (depth0 != null ? lookupProperty(depth0,"ReadPointAddress") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"ReadPointAddress","hash":{},"data":data,"loc":{"start":{"line":61,"column":67},"end":{"line":61,"column":87}}}) : helper)))
    + "<span id=\"sortReadPtAddressIconId\">&#9650;</span></div>\n				<div class=\"modbus-comp-table-cell\" id =\"readPtOperationModeCellId\" >"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"ReadPointOperationMode") || (depth0 != null ? lookupProperty(depth0,"ReadPointOperationMode") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"ReadPointOperationMode","hash":{},"data":data,"loc":{"start":{"line":62,"column":73},"end":{"line":62,"column":99}}}) : helper)))
    + "<span id=\"sortReadPtOperationModeIconId\"></span></div>\n				<div class=\"modbus-comp-table-cell\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"ReadPointPollTime") || (depth0 != null ? lookupProperty(depth0,"ReadPointPollTime") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"ReadPointPollTime","hash":{},"data":data,"loc":{"start":{"line":63,"column":40},"end":{"line":63,"column":61}}}) : helper)))
    + "</div>\n				<div class=\"modbus-comp-table-cell\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"ScalingFactor") || (depth0 != null ? lookupProperty(depth0,"ScalingFactor") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"ScalingFactor","hash":{},"data":data,"loc":{"start":{"line":64,"column":40},"end":{"line":64,"column":57}}}) : helper)))
    + "</div>\n				<div class=\"modbus-comp-table-cell\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"ReadDataFormat") || (depth0 != null ? lookupProperty(depth0,"ReadDataFormat") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"ReadDataFormat","hash":{},"data":data,"loc":{"start":{"line":65,"column":40},"end":{"line":65,"column":58}}}) : helper)))
    + "</div>\n				<div class=\"modbus-comp-table-cell\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"EventBitMasking") || (depth0 != null ? lookupProperty(depth0,"EventBitMasking") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"EventBitMasking","hash":{},"data":data,"loc":{"start":{"line":66,"column":40},"end":{"line":66,"column":59}}}) : helper)))
    + "</div>\n				<div class=\"modbus-comp-table-cell\" ><input id=\"selecetAllReadPtIdChkBox\" type=\"checkbox\">SelectAll</input></div>\n			  </div>			  \n			</div>\n			<div class=\"modbus-comp-table-body\" id=\"readPointTableBodyId\" >\n						  \n			  <!--  div class=\"md-table-row\" onmouseover=\"this.style.background='#E8E8E8';\" onmouseout=\"this.style.background='#ffffff';\">\n				<div class=\"modbus-comp-table-cell\">RoomTemparature1RoomTemparature1</div>\n				<div class=\"modbus-comp-table-cell\">sdsdsd dsd skhsahd</div>\n				<div class=\"modbus-comp-table-cell\">sdsds ds ds </div>\n				<div class=\"modbus-comp-table-cell\">sdsds dsdsd ds</div>\n				<div class=\"modbus-comp-table-cell\">sdsdsd dsd </div>\n				<div class=\"modbus-comp-table-cell\">sdsds ds ds </div>\n				<div class=\"modbus-comp-table-cell\">sdsdsd dsd </div>\n				<div class=\"modbus-comp-table-cell\"><input type=\"checkbox\" /></div>\n			  </div-->\n\n		</div> \n		 \n		</div>\n	    </div>\n\n		<div id=\"pointWriteTabId\" class=\"tabcontent\">\n		<div class=\"button-container\">\n		  <div class=\"div-inline\">\n		  		<label for=\"Write Points Count\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"WritePointsCount") || (depth0 != null ? lookupProperty(depth0,"WritePointsCount") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"WritePointsCount","hash":{},"data":data,"loc":{"start":{"line":91,"column":38},"end":{"line":91,"column":58}}}) : helper)))
    + "</label>\n		  		<label id=\"writePointCountId\"></label>\n				<!-- input class=\"form-element-small form-element-text-left\" id=\"writePointCountId\" type=\"text\" value=\"\" readonly /-->\n		  </div>\n		  <div class=\"div-inline\"><button class=\"common-button\" id =\"addButtonWritePointId\">Add</button></div>\n		  <div class=\"div-inline\"><button class=\"common-button\"  id =\"deleteButtonWritePointId\">Delete</button></div>\n		</div>\n			    <div class=\"modbus-comp-table\">		 \n			<div class=\"modbus-comp-table-header\">\n			  <div class=\"md-table-row\">\n			    <div class=\"modbus-comp-table-cell\" id =\"writePtNameCellId\" >"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"WritePointName") || (depth0 != null ? lookupProperty(depth0,"WritePointName") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"WritePointName","hash":{},"data":data,"loc":{"start":{"line":101,"column":68},"end":{"line":101,"column":86}}}) : helper)))
    + "<span id=\"sortWritePtNameIconId\"></span></div>\n				<div class=\"modbus-comp-table-cell\" id =\"writePtTypeCellId\" >"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"WritePointType") || (depth0 != null ? lookupProperty(depth0,"WritePointType") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"WritePointType","hash":{},"data":data,"loc":{"start":{"line":102,"column":65},"end":{"line":102,"column":83}}}) : helper)))
    + "<span id=\"sortWritePtTypeIconId\"></span></div>				\n				<div class=\"modbus-comp-table-cell\" id =\"writePtAddressCellId\" >"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"WritePointAddress") || (depth0 != null ? lookupProperty(depth0,"WritePointAddress") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"WritePointAddress","hash":{},"data":data,"loc":{"start":{"line":103,"column":68},"end":{"line":103,"column":89}}}) : helper)))
    + "<span id=\"sortWritePtAddressIconId\">&#9650;</span></div>\n				<div class=\"modbus-comp-table-cell\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"SignificantChange") || (depth0 != null ? lookupProperty(depth0,"SignificantChange") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"SignificantChange","hash":{},"data":data,"loc":{"start":{"line":104,"column":40},"end":{"line":104,"column":61}}}) : helper)))
    + "</div>\n				<div class=\"modbus-comp-table-cell\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"WriteDataFormat") || (depth0 != null ? lookupProperty(depth0,"WriteDataFormat") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"WriteDataFormat","hash":{},"data":data,"loc":{"start":{"line":105,"column":40},"end":{"line":105,"column":59}}}) : helper)))
    + "</div>\n				<div class=\"modbus-comp-table-cell\"  ><input id=\"selecetAllWritePtIdChkBox\" type=\"checkbox\">SelectAll</input></div>\n			  </div>			  \n			</div>\n			\n			<div class=\"modbus-comp-table-body\"  id=\"writePointTableBodyId\" >						  		  \n		   </div> \n		 \n		</div>\n		\n		</div>\n   </div>\n	\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/honIrmControl/rc/templates/modbusDeviceView', t);
return t;
});
/* END_TEMPLATE */
;
/* START_TEMPLATE */
define('hbs!nmodule/honIrmControl/rc/templates/modbusReadPointDialog',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "<div class=\"main-container-modbus-view\" >\n<div class=\"device-prop-container\">\n		<div class=\"device-prop-wrapper\">\n			<div class=\"device-properties-1\">\n			   <div class=\"form-wrapper\">\n				<label for=\"Read Point Name\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"ReadPointName") || (depth0 != null ? lookupProperty(depth0,"ReadPointName") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"ReadPointName","hash":{},"data":data,"loc":{"start":{"line":6,"column":33},"end":{"line":6,"column":50}}}) : helper)))
    + "</label>\n				<input class=\"form-element form-element-text-left\" id=\"readPointNameDialogId\" type=\"text\" value=\"\"  />\n				</div>			\n			</div>\n			<div class=\"device-properties-2\">\n			   <div class=\"form-wrapper\">\n				<label for=\"Read Point Address\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"ReadPointAddressDialog") || (depth0 != null ? lookupProperty(depth0,"ReadPointAddressDialog") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"ReadPointAddressDialog","hash":{},"data":data,"loc":{"start":{"line":12,"column":36},"end":{"line":12,"column":62}}}) : helper)))
    + "</label>\n				<div>\n				<input class=\"form-element form-element-text-left\" id=\"readPointAddressDialogId\" type=\"text\" value=\"\"  />\n				<label for=\"ReadPointAddressDialogRange\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointAddressRange") || (depth0 != null ? lookupProperty(depth0,"pointAddressRange") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointAddressRange","hash":{},"data":data,"loc":{"start":{"line":15,"column":45},"end":{"line":15,"column":66}}}) : helper)))
    + "</label>\n				</div>\n				</div>			\n			</div>\n			<div class=\"device-properties-3\">\n				<div class=\"form-wrapper\">\n				<label for=\"Read Point Type\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"ReadPointType") || (depth0 != null ? lookupProperty(depth0,"ReadPointType") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"ReadPointType","hash":{},"data":data,"loc":{"start":{"line":21,"column":33},"end":{"line":21,"column":50}}}) : helper)))
    + "</label>\n				<select id=\"readPointTypeDialogId\" class=\"form-element\" >\n				</select>\n				</div>\n			</div>\n		</div>	\n		\n		<div class=\"device-prop-wrapper\">\n			<div class=\"device-properties-4\">\n				<div class=\"form-wrapper\">\n				<label for=\"Read Point Operation Mode\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"ReadPointOperationMode") || (depth0 != null ? lookupProperty(depth0,"ReadPointOperationMode") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"ReadPointOperationMode","hash":{},"data":data,"loc":{"start":{"line":31,"column":43},"end":{"line":31,"column":69}}}) : helper)))
    + "</label>\n				<select id=\"readPointOperationModeDialogId\" class=\"form-element\" >\n				</select>\n				</div>		\n			</div>	\n			<div class=\"device-properties-5\">\n				<div class=\"form-wrapper\">\n				<label for=\"Scaling Factor\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"ScalingFactor") || (depth0 != null ? lookupProperty(depth0,"ScalingFactor") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"ScalingFactor","hash":{},"data":data,"loc":{"start":{"line":38,"column":32},"end":{"line":38,"column":49}}}) : helper)))
    + "</label>\n				<div>\n				<input class=\"form-element form-element-text-left\" id=\"scalingFactorDialogId\" type=\"number\" min=\"-3\" max=\"3\" value=\"\"  />\n				<label for=\"scalingFactor Range\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"ScalingFactorRange") || (depth0 != null ? lookupProperty(depth0,"ScalingFactorRange") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"ScalingFactorRange","hash":{},"data":data,"loc":{"start":{"line":41,"column":37},"end":{"line":41,"column":59}}}) : helper)))
    + "</label>\n				</div>\n				</div>\n			</div>\n			<div class=\"device-properties-6\">\n				<div class=\"form-wrapper\">\n				<label for=\"Data Format\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"ReadDataFormat") || (depth0 != null ? lookupProperty(depth0,"ReadDataFormat") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"ReadDataFormat","hash":{},"data":data,"loc":{"start":{"line":47,"column":29},"end":{"line":47,"column":47}}}) : helper)))
    + "</label>\n				<select id=\"dataFormatDialogId\" class=\"form-element\" >\n				</select>\n				</div>\n			</div>				\n		</div>\n </div>\n \n <div class=\"device-prop-container\">		\n		<div class=\"device-prop-wrapper\">\n			<div class=\"device-properties-7\">\n				<div class=\"form-wrapper\">\n				<label for=\"Read Point Poll Time\" id=\"readPointPollTimeLabelId\" >"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"ReadPointPollTime") || (depth0 != null ? lookupProperty(depth0,"ReadPointPollTime") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"ReadPointPollTime","hash":{},"data":data,"loc":{"start":{"line":59,"column":69},"end":{"line":59,"column":90}}}) : helper)))
    + "</label>\n				<div>\n				<input class=\"form-element form-element-text-left\" id=\"readPointPollTimeDialogId\" type=\"number\" min=\"1\" max=\"86400\" value=\"\" />\n				<label for=\"EventBitMaskingRange\" id=\"readPointPollTimeRangeLabelId\" >"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"ReadPointPollTimeRange") || (depth0 != null ? lookupProperty(depth0,"ReadPointPollTimeRange") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"ReadPointPollTimeRange","hash":{},"data":data,"loc":{"start":{"line":62,"column":74},"end":{"line":62,"column":100}}}) : helper)))
    + "</label>\n				</div>\n				</div>\n			</div>	\n			<div class=\"device-properties-8\">\n				<div class=\"form-wrapper\">\n				<label for=\"Event Bit Masking\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"EventBitMasking") || (depth0 != null ? lookupProperty(depth0,"EventBitMasking") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"EventBitMasking","hash":{},"data":data,"loc":{"start":{"line":68,"column":35},"end":{"line":68,"column":54}}}) : helper)))
    + "</label>\n				<div>\n				<input class=\"form-element form-element-text-left\" id=\"eventBitMaskingDialogId\" type=\"text\" value=\"FFFFFFFF\"  />\n				<label for=\"EventBitMaskingRange\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"EventBitMaskingRange") || (depth0 != null ? lookupProperty(depth0,"EventBitMaskingRange") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"EventBitMaskingRange","hash":{},"data":data,"loc":{"start":{"line":71,"column":38},"end":{"line":71,"column":62}}}) : helper)))
    + "</label>\n				</div>\n				</div>\n			</div>					\n		</div>	\n  </div>\n  </div>\n	\n	\n";
},"useData":true});
Handlebars.registerPartial('nmodule/honIrmControl/rc/templates/modbusReadPointDialog', t);
return t;
});
/* END_TEMPLATE */
;
/* START_TEMPLATE */
define('hbs!nmodule/honIrmControl/rc/templates/modbusWritePointDialog',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "<div class=\"main-container-modbus-view\" >\n<div class=\"device-prop-container\">\n		<div class=\"device-prop-wrapper\">\n			<div class=\"device-properties-1\">\n			   <div class=\"form-wrapper\">\n				<label for=\"Write Point Name\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"WritePointName") || (depth0 != null ? lookupProperty(depth0,"WritePointName") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"WritePointName","hash":{},"data":data,"loc":{"start":{"line":6,"column":34},"end":{"line":6,"column":52}}}) : helper)))
    + "</label>\n				<input class=\"form-element form-element-text-left\" id=\"writePointNameDialogId\" type=\"text\" value=\"\"  />\n				</div>			\n			</div>\n			<div class=\"device-properties-2\">\n			   <div class=\"form-wrapper\">\n				<label for=\"Write Point Address\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"WritePointAddressDialog") || (depth0 != null ? lookupProperty(depth0,"WritePointAddressDialog") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"WritePointAddressDialog","hash":{},"data":data,"loc":{"start":{"line":12,"column":37},"end":{"line":12,"column":64}}}) : helper)))
    + "</label>\n				<div>\n				<input class=\"form-element form-element-text-left\" id=\"writePointAddressDialogId\" type=\"text\" value=\"\"  />\n				<label for=\"ReadPointAddressDialogRange\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointAddressRange") || (depth0 != null ? lookupProperty(depth0,"pointAddressRange") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointAddressRange","hash":{},"data":data,"loc":{"start":{"line":15,"column":45},"end":{"line":15,"column":66}}}) : helper)))
    + "</label>\n				</div>\n				</div>			\n			</div>\n			<div class=\"device-properties-3\">\n				<div class=\"form-wrapper\">\n				<label for=\"Write Point Type\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"WritePointType") || (depth0 != null ? lookupProperty(depth0,"WritePointType") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"WritePointType","hash":{},"data":data,"loc":{"start":{"line":21,"column":34},"end":{"line":21,"column":52}}}) : helper)))
    + "</label>\n				<select id=\"writePointTypeDialogId\" class=\"form-element\" >\n				</select>\n				</div>\n			</div>\n\n		</div>	\n		\n		<div class=\"device-prop-wrapper\">	\n			<div class=\"device-properties-4\">\n				<div class=\"form-wrapper\">\n				<label for=\"Write Point Data Format\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"WritePointDataFormat") || (depth0 != null ? lookupProperty(depth0,"WritePointDataFormat") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"WritePointDataFormat","hash":{},"data":data,"loc":{"start":{"line":32,"column":41},"end":{"line":32,"column":65}}}) : helper)))
    + "</label>\n				<select id=\"writePointDataFormatDialogId\" class=\"form-element\" >\n				</select>\n				</div>		\n			</div>\n			<div class=\"device-properties-5\">\n				<div class=\"form-wrapper\">\n				<label for=\"Significant Change\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"SignificantChange") || (depth0 != null ? lookupProperty(depth0,"SignificantChange") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"SignificantChange","hash":{},"data":data,"loc":{"start":{"line":39,"column":36},"end":{"line":39,"column":57}}}) : helper)))
    + "</label>\n				<input class=\"form-element form-element-text-left\" id=\"significantChangeDialogId\" type=\"number\" value=\"\"  />\n				</div>\n			</div>			\n		</div>	\n </div>\n  </div>	\n";
},"useData":true});
Handlebars.registerPartial('nmodule/honIrmControl/rc/templates/modbusWritePointDialog', t);
return t;
});
/* END_TEMPLATE */
;

/**
 * A module defining `ModbusUtil`.
 *
 * @module nmodule/honIrmControl/rc/ModbusUtil
 */
define('nmodule/honIrmControl/rc/ModbusUtil',['baja!',
        'bajaux/Widget',
        'dialogs',
        'lex!honIrmControl', 
        'jquery'], function ( 
        baja,
        Widget,
        dialogs,
        lexicons,
        $ ) {
	
	
	  	  
	  
	  var honIrmControlLex = lexicons[0];
	
	var ModbusUtil = function ModbusUtil() {
	      Widget.apply(this, arguments);
	  };
	  
	  ModbusUtil.prototype = Object.create(Widget.prototype);
	  ModbusUtil.prototype.constructor = ModbusUtil;
	  
	  ModbusUtil.seventeenNumber = 17;
	  ModbusUtil.eighteenNumber = 18;
	  
	   /**
	    * num here is in decimal
	    */
	  ModbusUtil.prototype.showAddressInDecAndHex = function(numInDec) {
	      var hex = Number(numInDec).toString(16).toUpperCase();
	      return numInDec +" / "+"0x"+this.pad(hex, 4);
	  }
	  /**
	   * num here is in hex with 0x
	   */
	  ModbusUtil.prototype.showAddressInDecAndHexFromHex = function(numInHex) {	 
		 var dec = parseInt(numInHex,16);
	     var hex = numInHex.toUpperCase();
	     return dec +" / "+ this.pad(hex, 4);
	 }
	 
	  ModbusUtil.prototype.pad = function(str, max) {
		  str = str.toString();
		  return str.length < max ? this.pad("0" + str, max) : str;
		}
	  
	  
	  ModbusUtil.prototype.showInHex = function(num) {
		  var numStr = num.toString();
		  if(numStr.includes("0x")){
			  numStr = numStr.substring(2);
		  }      
	      return "0x"+this.pad(numStr, 8).toUpperCase(); 
	      
	  }
	  
	  ModbusUtil.prototype.convertAndshowInHex = function(num) {
	      var hex = Number(num).toString(16).toUpperCase();
	      return "0x"+this.pad(hex, 8);
	  }
	  
	  ModbusUtil.prototype.showErrorDiaogOnAddEditPointSameName = function(ptTypeRead,ptName){
			 dialogs.showOk({
				  title:ptTypeRead == true ?honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.error.title'):honIrmControlLex.get('honIrmControlLex.writepoint.add.edit.error.title'),
				  content:honIrmControlLex.get('honIrmControlLex.add.edit.same.name',ptName),
				  private: false
				  })
				  .ok(function () {
				    return true;
				  });
			 return true;
		}
	  
	  
	  ModbusUtil.prototype.showErrorDiaogOnAddEditPointOnAdress = function(ptTypeRead,address,ptName){
			 
		    dialogs.showOk({
				  title:ptTypeRead == true ?honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.error.title'):honIrmControlLex.get('honIrmControlLex.writepoint.add.edit.error.title'),
				  content:ptTypeRead == true ?honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.address.validation',ptName,address):honIrmControlLex.get('honIrmControlLex.writepoint.add.edit.address.validation',ptName,address),
				  private: false
			     })
			     .ok(function () {
				    return true;
				  });
			 return true;
	 }
	  
	  ModbusUtil.prototype.showWarningDialogAndPtsTobeDeleted = function(ptTypeRead){
			 dialogs.showOk({
				  title:ptTypeRead == true ?honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.error.title'):honIrmControlLex.get('honIrmControlLex.writepoint.add.edit.error.title'),
				  content:ptTypeRead == true ?honIrmControlLex.get('honIrmControlLex.readpoint.no.chkbox.selected'):honIrmControlLex.get('honIrmControlLex.writepoint.no.chkbox.selected'),
				  private: false	  
			       })
				 .ok(function () {
					 return true;
				  });
		 }
	  
	  ModbusUtil.prototype.checkStirngAsNullOrEmpty = function(value){
			if (value == null || value.trim() === ''){
				  return true;
				}
			 return false;
		}
		 

	  return ModbusUtil;
	
});


/**
 * A module defining `ModbusReadPointsConfig`.
 *
 * @module nmodule/honIrmControl/rc/ModbusReadPointsConfig
 */
define('nmodule/honIrmControl/rc/ModbusReadPointsConfig',['baja!',
        'bajaux/Widget',
        'css!nmodule/honIrmControl/rc/css/irmnx-styles',
        'css!nmodule/honIrmControl/rc/css/comp-table',
        'nmodule/honIrmControl/rc/ModbusUtil',
        'lex!honIrmControl',
        'dialogs',
        'jquery'], function ( 
        baja,
        Widget,
        css,
        tablecss,
        ModbusUtil,
        lexicons,
        dialogs,
        $ ) {
	
	
	  	
	  var honIrmControlLex = lexicons[0];
	
	var ModbusReadPointsConfig = function ModbusReadPointsConfig() {
	      Widget.apply(this, arguments);
	  };
	  
	  ModbusReadPointsConfig.prototype = Object.create(Widget.prototype);
	  ModbusReadPointsConfig.prototype.constructor = ModbusReadPointsConfig;  
	  
	  var modbusUtil = new ModbusUtil();
	  
	  
	  ModbusReadPointsConfig.prototype.getReadPointTableId = function(dom) {		
			return dom.find('#readPointTableBodyId');
		}
	  
	    //read pts filter
      ModbusReadPointsConfig.readPtAddressFilterDsc = "readPtAddressFilterDsc";
	  ModbusReadPointsConfig.readPtAddressFilterAsc = "readPtAddressFilterAsc";
	  ModbusReadPointsConfig.readPtNameFilterDsc = "readPtNameFilterDsc";
	  ModbusReadPointsConfig.readPtNameFilterAsc = "readPtNameFilterAsc";
	  ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtAddressFilterAsc;
	  ModbusReadPointsConfig.readPtTypeFilterDsc = "readPtTypeFilterDsc";
	  ModbusReadPointsConfig.readPtTypeFilterAsc = "readPtTypeFilterAsc";
	  ModbusReadPointsConfig.readPtOperationModeFilterDsc = "readPtOperationModeFilterDsc";
	  ModbusReadPointsConfig.readPtOperationModeFilterAsc = "readPtOperationModeFilterAsc";
	
	  ModbusReadPointsConfig.selectAllReadPtIdChkBox = '#selecetAllReadPtIdChkBox';
	  ModbusReadPointsConfig.checkBoxReadPoint = '#checkBoxReadPoint';
	  ModbusReadPointsConfig.userDefinedMode = 5;

	  function sortReadTableByFilter(ptsArray,filter){
		  
		  if(filter === ModbusReadPointsConfig.readPtAddressFilterAsc){
			  ptsArray.sort(function(readPoint, readPointNext){
	    	    return readPoint.readPtAddress-readPointNext.readPtAddress;
	    	});
		  }else if(filter === ModbusReadPointsConfig.readPtAddressFilterDsc){
			  ptsArray.sort(function(readPoint, readPointNext){
		    	    return readPointNext.readPtAddress-readPoint.readPtAddress;
		    });  
		  }else if(filter === ModbusReadPointsConfig.readPtNameFilterDsc){
			  ptsArray.sort(function(readPoint, readPointNext){
		    	    return readPointNext.readPtName.localeCompare(readPoint.readPtName);
		   });
		  }else if(filter === ModbusReadPointsConfig.readPtNameFilterAsc){
			  ptsArray.sort(function(readPoint, readPointNext){
		    	    return readPoint.readPtName.localeCompare(readPointNext.readPtName);
		    });		  
	      }
		  else if(filter === ModbusReadPointsConfig.readPtTypeFilterDsc){
			  ptsArray.sort(function(readPoint, readPointNext){
		    	    return readPointNext.readOptionPointTypeVal.localeCompare(readPoint.readOptionPointTypeVal);
		    });
	      }else if(filter === ModbusReadPointsConfig.readPtTypeFilterAsc){
			  ptsArray.sort(function(readPoint, readPointNext){
		    	    return readPoint.readOptionPointTypeVal.localeCompare(readPointNext.readOptionPointTypeVal);
		    });
	      }else if(filter === ModbusReadPointsConfig.readPtOperationModeFilterDsc){
			  ptsArray.sort(function(readPoint, readPointNext){
		    	    return  readPointNext.readPtOperationModeVal.localeCompare(readPoint.readPtOperationModeVal);
		    });
	      }else if(filter === ModbusReadPointsConfig.readPtOperationModeFilterAsc){
			  ptsArray.sort(function(readPoint, readPointNext){
		    	    return readPoint.readPtOperationModeVal.localeCompare(readPointNext.readPtOperationModeVal);
		   });
	    }
	      
	      return ptsArray;
	  }
	  
	  
	  ModbusReadPointsConfig.prototype.sortReadTableOnSelectedFilter = function(widget,filter){
	      var dom = widget.jq();
	      
	      var readPtsArray =  sortReadTableByFilter(Object.values(widget.readPointDataList),filter);
		  	      
		  var readPointTableBody = this.getReadPointTableId(dom);
	      var readPointRows = readPointTableBody.find(".md-table-row");
		  var totalNoOfReadPts = readPointRows.length;
		  var objReadPointValues = Object.assign({},readPointRows);
		  
		  
		  
	      for (var i = 0; i <totalNoOfReadPts; i++) {   
	    	  var readPointRowIdHash = readPtsArray[i].rowIdJq;
	    	  var readPointRowId = readPointRowIdHash.substring(1,readPointRowIdHash.length);
		  	 objReadPointValues[i].setAttribute("id",readPointRowId);	  	   
		  	 var readPointcells = objReadPointValues[i].getElementsByClassName("modbus-comp-table-cell");
			  for (var l = 0; l <readPointcells.length; l++) { // 0 1 2 3
					 if( l==0 ){
						 readPointcells[l].innerText = readPtsArray[i].readPtName;
						 readPointcells[l].setAttribute("data",readPtsArray[i].readPtName);
						 readPointcells[l].setAttribute("title",readPtsArray[i].readPtName);
					 }
					 else if(l==1){		 
						 readPointcells[l].innerText = readPtsArray[i].readOptionPointTypeVal;
						 readPointcells[l].setAttribute("data",readPtsArray[i].readPtTypeOrdinal);
						 readPointcells[l].setAttribute("title",readPtsArray[i].readOptionPointTypeVal);
					 }			 
					 else if(l==2){
						 
						 if(readPtsArray[i].readPtAddress.toString().toUpperCase().includes("0X")){
							 readPointcells[l].innerText = modbusUtil.showAddressInDecAndHexFromHex(readPtsArray[i].readPtAddress);
						 }else{
							 readPointcells[l].innerText = modbusUtil.showAddressInDecAndHex(readPtsArray[i].readPtAddress);
						 }
						 
						 readPointcells[l].setAttribute("data", readPtsArray[i].readPtAddress);
					 }				 
					 else if(l==3){
						 readPointcells[l].innerText = readPtsArray[i].readPtOperationModeVal;
						 readPointcells[l].setAttribute("data",readPtsArray[i].readPtOperationMode); 
					 }
					 else if(l==4){
						 readPointcells[l].innerText = readPtsArray[i].readPtPollTime;
						 readPointcells[l].setAttribute("data",readPtsArray[i].readPtPollTime); 
					 }
					 else if(l==5){			 
						 readPointcells[l].innerText = readPtsArray[i].readPtScalingFactor;
						 readPointcells[l].setAttribute("data",readPtsArray[i].readPtScalingFactor); 
					 } 
					 else if(l==6){
						 readPointcells[l].innerText = readPtsArray[i].optionPointDataFormatVal;
						 readPointcells[l].setAttribute("data",readPtsArray[i].readPtDataFormat); 
					 } 
					 else if(l==7){
						 readPointcells[l].innerText = modbusUtil.showInHex(readPtsArray[i].readPtEventBitMasking);
						 readPointcells[l].setAttribute("data",readPtsArray[i].readPtEventBitMasking); 
					 }
					 else if(l==8){		 
						  var countStr= readPointRowId.substring(ModbusUtil.seventeenNumber),
						  count = Number(countStr);
						  var readPointTableCheckRowId = "checkBoxReadPoint"+count;						 
						  readPointcells[l].getElementsByTagName("input")[0].setAttribute("id",readPointTableCheckRowId);
					 }  
				  } 
		  
		  	  }				  
  }
	  	  
	  ModbusReadPointsConfig.prototype.checkAllCheckBoxSelectedFromReadTable = function(widget){
		  // If select all button is checked
	      var dom = widget.jq()
		  var readPointTableBody = this.getReadPointTableId(dom);
	      var readPointRows = readPointTableBody.find(".md-table-row");
		  var totalNoOfReadPts = readPointRows.length;
		  for (var i = 0; i <totalNoOfReadPts; i++) {
			  var readPointRowId = readPointRows[i].getAttribute("id");
			  var count= readPointRowId.substring(ModbusUtil.seventeenNumber),
			  count = Number(count);
			  var readPointTableCheckRowId = ModbusReadPointsConfig.checkBoxReadPoint+count;
			  if(dom.find(readPointTableCheckRowId).prop("checked") == false){
				  return false;
			  }
		  }	
		  return true;
		// selected check box row will be deleted
	  }
	  
	  ModbusReadPointsConfig.prototype.handleSelectAllCheckBoxStatusFromReadPointsTable= function(readPtRowChkBox,widget){
		  if($(readPtRowChkBox).prop("checked") == false){				  
			  $(ModbusReadPointsConfig.selectAllReadPtIdChkBox).prop("checked",false);			  
		     }else{
		    	 if(this.checkAllCheckBoxSelectedFromReadTable(widget) == true)
		    		 {
		    		  $(ModbusReadPointsConfig.selectAllReadPtIdChkBox).prop("checked",true);		
		    		 }
		     }		  
		  }
	  
	  ModbusReadPointsConfig.prototype.selectAllCheckBoxFromReadPointsTable = function(widget){
		  //If select all button is checked
		      var dom = widget.jq()
			  var readPointTableBody = this.getReadPointTableId(dom);
		      var readPointRows = readPointTableBody.find(".md-table-row");
			  var totalNoOfReadPts = readPointRows.length;
			  var objReadPointValues = Object.assign({},readPointRows);
			  for (var i = 0; i <totalNoOfReadPts; i++) {
				  var readPointRowId = objReadPointValues[i].getAttribute("id");
				  var count= readPointRowId.substring(ModbusUtil.seventeenNumber),
				  count = Number(count);
				  var readPointTableCheckRowId = ModbusReadPointsConfig.checkBoxReadPoint+count;
				  if(dom.find(ModbusReadPointsConfig.selectAllReadPtIdChkBox).prop("checked") == true){
					  dom.find(readPointTableCheckRowId).prop("checked",true);
				  }else{
					  dom.find(readPointTableCheckRowId).prop("checked",false);
				  }		  
			  }			  
			//selected check box row will be deleted  
		  }
	  
	  
	  ModbusReadPointsConfig.prototype.validateReadPtAddressAndType = function(modBusPtsReadList,modBusPt,modBusPtsWriteList){
		  for(var i in modBusPtsReadList){
			  //should not compare with itself
			  if(modBusPtsReadList[i].rowIdJq == modBusPt.rowIdJq){
				  continue;
			  }
			  if(modBusPtsReadList[i].readPtAddress == modBusPt.readPtAddress){		  
					  
				  if(modBusPtsReadList[i].readPtTypeOrdinal == modBusPt.readPtTypeOrdinal){
					  var isErrorShown = modbusUtil.showErrorDiaogOnAddEditPointOnAdress(true,modBusPtsReadList[i].readPtAddress,modBusPtsReadList[i].readPtName);
					  return isErrorShown;
				  }
			  }
			  if(modBusPtsReadList[i].readPtName === modBusPt.readPtName){
				  var isSameNameErrorShown = modbusUtil.showErrorDiaogOnAddEditPointSameName(true,modBusPt.readPtName);
				  return isSameNameErrorShown;
			  }
		  } 
		  
		  for(var j in modBusPtsWriteList){
			  if(modBusPtsWriteList[j].writePtName === modBusPt.readPtName){
				  var isSameNameErrorShownWritePt = modbusUtil.showErrorDiaogOnAddEditPointSameName(true,modBusPt.readPtName);
				  return isSameNameErrorShownWritePt;
			  } 
		  }
		  return false;	  
	 }
	  
	  ModbusReadPointsConfig.prototype.showErrorDiaogOnAddEditReadPoint = function(scalingFactorVal,readPointAddressVal,readPointNameVal,eventBitMaskingVal,readPtPollTime,readPtOperationModeVal){
		  
			 
		  var scalingFactorEmpty =  modbusUtil.checkStirngAsNullOrEmpty(scalingFactorVal);
		  var pointAddressrEmpty =  modbusUtil.checkStirngAsNullOrEmpty(readPointAddressVal);
		  var pointNameEmpty =  modbusUtil.checkStirngAsNullOrEmpty(readPointNameVal);
		  var eventBitMaskingEmpty =  modbusUtil.checkStirngAsNullOrEmpty(eventBitMaskingVal);
		  if(scalingFactorEmpty == true || pointAddressrEmpty == true || pointNameEmpty == true || eventBitMaskingEmpty == true){
			 dialogs.showOk({
				  title: honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.error.title'),
				  content: honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.error'),
				  private: false
			     })
				  .ok(function () {
				    return true;
				  });
			 return true;
		  }
		  if(scalingFactorVal >3 || scalingFactorVal <-3){
				 dialogs.showOk({
					  title: honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.error.title'),
					  content: honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.scalingFactor.error'),
					  private: false
				     })
					  .ok(function () {
					    return true;
					  });
					
				 return true;
		  }
		  if((readPtOperationModeVal == ModbusReadPointsConfig.userDefinedMode))
		 {
		    if( readPtPollTime >86400 ||  readPtPollTime <1){
				 dialogs.showOk({
					  title: honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.error.title'),
					  content: honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.readPtPollTime.error'),
					  private: false
				     })
					  .ok(function () {
					    return true;
					  });
					
				 return true;
		       }
			}
		  
		  //check for read point address nan value
		  if(isNaN(readPointAddressVal)){
				 dialogs.showOk({
					  title: honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.error.title'),
					  content: honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.readPointAddressVal.nan.error'),
					  private: false
				     })
					  .ok(function () {
					    return true;
					  });
					
				 return true;
		  }
		  //check for limit value
		  if(readPointAddressVal.toString().toUpperCase().includes("0X")){
			  if(readPointAddressVal > 0xFFFF || readPointAddressVal < 0) {
					 dialogs.showOk({
						  title: honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.error.title'),
						  content: honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.readPointAddressVal.hex.limit.error'),
						  private: false
					     })
						  .ok(function () {
						    return true;
						  });
						
					 return true;
				  
			  }
		  }else{
			  if(readPointAddressVal > 65535 || readPointAddressVal < 0 ){
					 dialogs.showOk({
						  title: honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.error.title'),
						  content: honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.readPointAddressVal.dec.limit.error'),
						  private: false
					     })
						  .ok(function () {
						    return true;
						  });
						
					 return true;
				  
			  }
		  }
		  
		  
		  if(isNaN(modbusUtil.showInHex(eventBitMaskingVal))){
				 dialogs.showOk({
					  title: honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.error.title'),
					  content: honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.eventBitMasking.nan.error'),
					  private: false
				     })
					  .ok(function () {
					    return true;
					  });
					
				 return true;
		  }
		  if(modbusUtil.showInHex(eventBitMaskingVal) >0xFFFFFFFF || modbusUtil.showInHex(eventBitMaskingVal) <0){
				 dialogs.showOk({
					  title: honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.error.title'),
					  content: honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.eventBitMasking.min.max.error'),
					  private: false
				     })
					  .ok(function () {
					    return true;
					  });
					
				 return true;
		  }
		  
	  }
	  ModbusReadPointsConfig.prototype.getModbusDeletedReadPointTableData = function(widget) {
			
	 		 var deleteReadPointList =  widget.deleteReadPointDataList;
	 		 var modbusDeviceDeleteInputContentsObj = baja.$('baja:Component');
	 		  
	 		 for (var key in deleteReadPointList){
	 			  var modbusDeviceDeletedReadPtArgsObj = baja.$('honIrmControl:ModbusReadPointDisplayArgs');
	 		      modbusDeviceDeletedReadPtArgsObj.setReadPointName( baja.SlotPath.escape(deleteReadPointList[key].readPtName));

	 			  modbusDeviceDeletedReadPtArgsObj.setOldFb(deleteReadPointList[key].oldFb);
	 			  modbusDeviceDeletedReadPtArgsObj.setOldPointName(deleteReadPointList[key].oldPointName);
	 			  modbusDeviceDeletedReadPtArgsObj.setExistingSlotPath(deleteReadPointList[key].existingSlotPath);
	 	          //while adding add the slot name with escaping the special character but while showing to user unescape and show to user
	 			  modbusDeviceDeleteInputContentsObj.add({
	 				slot: modbusDeviceDeletedReadPtArgsObj.getReadPointName(),
	 			    value: modbusDeviceDeletedReadPtArgsObj
	 			   })
	 			  .then(function (prop) {
	 				})
	 			  .catch(function (err) {
	 				   baja.error(err);				      
	 			  });
	 			}  	  
		  
		  return modbusDeviceDeleteInputContentsObj;
	  }
	  
	  
	  
	  ModbusReadPointsConfig.prototype.getModbusReadPointTableData = function(dom, widget) {

		  var readPointList =  widget.readPointDataList;
		  var modbusDeviceInputContentsObj = baja.$('baja:Component');
		  
		  var ptNameArr = [];
		  
		  for (var key in readPointList) {
			  var modbusDeviceReadPtArgsObj = baja.$('honIrmControl:ModbusReadPointDisplayArgs');
			  //while adding add the slot name with escaping the special character but while showing to user unescape and show to user
			  modbusDeviceReadPtArgsObj.setReadPointName( baja.SlotPath.escape(readPointList[key].readPtName));
			  ptNameArr.push(readPointList[key].readPtName);
			  var readPointTypeEnum = baja.DynamicEnum.make(parseInt(readPointList[key].readPtTypeOrdinal));
			  modbusDeviceReadPtArgsObj.setReadPointType(readPointTypeEnum);
			  if(readPointList[key].readPtAddress.toString().toUpperCase().includes("0X")){
				  modbusDeviceReadPtArgsObj.setReadPointAddress(parseInt(readPointList[key].readPtAddress.toString(),16));
			  }else{
				  modbusDeviceReadPtArgsObj.setReadPointAddress(readPointList[key].readPtAddress);  
			  }
			  
			  var readPointOperationModeTypeEnum = baja.DynamicEnum.make(parseInt(readPointList[key].readPtOperationMode));
			  modbusDeviceReadPtArgsObj.setOperationMode(readPointOperationModeTypeEnum);
			  modbusDeviceReadPtArgsObj.setPollTime(readPointList[key].readPtPollTime);
			  modbusDeviceReadPtArgsObj.setScalingFactor(readPointList[key].readPtScalingFactor);
			  var dataFormatTypeEnum = baja.DynamicEnum.make(parseInt(readPointList[key].readPtDataFormat));
			  modbusDeviceReadPtArgsObj.setDataFormat(dataFormatTypeEnum);
			  modbusDeviceReadPtArgsObj.setOldFb(readPointList[key].oldFb);
			  modbusDeviceReadPtArgsObj.setOldPointName(readPointList[key].oldPointName);
			  modbusDeviceReadPtArgsObj.setExistingSlotPath(readPointList[key].existingSlotPath);
			  var hexValue = modbusUtil.showInHex(readPointList[key].readPtEventBitMasking);
			  modbusDeviceReadPtArgsObj.setEventBitMasking(parseInt(hexValue)); //while saving send as decimal i.e. as long it will be saved
	          //while adding add the slot name with escaping the special character but while showing to user unescape and show to user
			  modbusDeviceInputContentsObj.add({
				slot: modbusDeviceReadPtArgsObj.getReadPointName(),
			    value: modbusDeviceReadPtArgsObj
			   })
			  .then(function (prop) {
				})
			  .catch(function (err) {
				   baja.error(err);				      
			  });

			}  	  
	 		for (var i = 0; i < ptNameArr.length; i++) { 
		   		   for(var j = i+1; j < ptNameArr.length; j++){
		   			   if(ptNameArr[i] === ptNameArr[j]){
		   				var isErrorShown = modbusUtil.showErrorDiaogOnAddEditPointSameName(true,ptNameArr[i]);
		   				if(isErrorShown == true){
		   					return true;
		   				}
		   			  }
		   		   }
		   		} 
		  
		  return modbusDeviceInputContentsObj;
	  }
	
	
	  return ModbusReadPointsConfig;
	
});

/**
 * A module defining `ModbusWritePointsConfig`.
 *
 * @module nmodule/honIrmControl/rc/ModbusWritePointsConfig
 */
define('nmodule/honIrmControl/rc/ModbusWritePointsConfig',['baja!',
        'bajaux/Widget',
        'css!nmodule/honIrmControl/rc/css/irmnx-styles',
        'css!nmodule/honIrmControl/rc/css/comp-table',
        'nmodule/honIrmControl/rc/ModbusUtil',
        'lex!honIrmControl',
        'dialogs',
        'jquery'], function ( 
        baja,
        Widget,
        css,
        tablecss,
        ModbusUtil,
        lexicons,
        dialogs,
        $ ) {
	
	
	  	
	  var honIrmControlLex = lexicons[0];
	
	var ModbusWritePointsConfig = function ModbusWritePointsConfig() {
	      Widget.apply(this, arguments);
	  };
	  
	  ModbusWritePointsConfig.prototype = Object.create(Widget.prototype);
	  ModbusWritePointsConfig.prototype.constructor = ModbusWritePointsConfig;  
	  
	  var modbusUtil = new ModbusUtil();
	  
	  
	  ModbusWritePointsConfig.prototype.getWritePointTableId = function(dom) {		
			return dom.find('#writePointTableBodyId');
		}
	  
	    //read pts filter
      ModbusWritePointsConfig.writePtAddressFilterDsc = "writePtAddressFilterDsc";
	  ModbusWritePointsConfig.writePtAddressFilterAsc = "writePtAddressFilterAsc";
	  ModbusWritePointsConfig.writePtNameFilterDsc = "writePtNameFilterDsc";
	  ModbusWritePointsConfig.writePtNameFilterAsc = "writePtNameFilterAsc";
	  ModbusWritePointsConfig.activeFilterWritePts = ModbusWritePointsConfig.writePtAddressFilterAsc;
	  ModbusWritePointsConfig.writePtTypeFilterDsc = "writePtTypeFilterDsc";
	  ModbusWritePointsConfig.writePtTypeFilterAsc = "writePtTypeFilterAsc";
	 
	
	  ModbusWritePointsConfig.selectAllWritePtIdChkBox = '#selecetAllWritePtIdChkBox';
	  ModbusWritePointsConfig.checkBoxWritePoint = '#checkBoxWritePoint';

	  function sortWriteTableByFilter(ptsArray,filter){
		  
		  if(filter === ModbusWritePointsConfig.writePtAddressFilterAsc){
			  ptsArray.sort(function(writePoint, writePointNext){
	    	    return writePoint.writePtAddress-writePointNext.writePtAddress;
	    	});
		  }else if(filter === ModbusWritePointsConfig.writePtAddressFilterDsc){
			  ptsArray.sort(function(writePoint, writePointNext){
		    	    return writePointNext.writePtAddress-writePoint.writePtAddress;
		    });  
		  }else if(filter === ModbusWritePointsConfig.writePtNameFilterDsc){
			  ptsArray.sort(function(writePoint, writePointNext){
		    	    return writePointNext.writePtName.localeCompare(writePoint.writePtName);
		   });
		  }else if(filter === ModbusWritePointsConfig.writePtNameFilterAsc){
			  ptsArray.sort(function(writePoint, writePointNext){
		    	    return writePoint.writePtName.localeCompare(writePointNext.writePtName);
		    });
		  }else if(filter === ModbusWritePointsConfig.writePtTypeFilterDsc){
			  ptsArray.sort(function(writePoint, writePointNext){
		    	    return writePointNext.writePtTypeValue.localeCompare(writePoint.writePtTypeValue);
		   });
		  }else if(filter === ModbusWritePointsConfig.writePtTypeFilterAsc){
			  ptsArray.sort(function(writePoint, writePointNext){
		    	    return writePoint.writePtTypeValue.localeCompare(writePointNext.writePtTypeValue);
		    });
		  }
	      
	      return ptsArray;
	  }
	  
	  ModbusWritePointsConfig.prototype.sortWriteTableOnSelectedFilter = function(widget,filter){
	      var dom = widget.jq();
	      
	      var writePtsArray = sortWriteTableByFilter(Object.values(widget.writePointDataList),filter);
		  	      
		  var writePointTableBody = this.getWritePointTableId(dom);
	      var writePointRows = writePointTableBody.find(".md-table-row");
		  var totalNoOfWritePts = writePointRows.length;
		  var objWritePointValues = Object.assign({},writePointRows);
		  
		  
	      for (var i = 0; i <totalNoOfWritePts; i++) {   
	    	  var writePointRowIdHash = writePtsArray[i].rowIdJq;
	    	  var writePointRowId = writePointRowIdHash.substring(1,writePointRowIdHash.length);
	    	  objWritePointValues[i].setAttribute("id",writePointRowId);	  	   
		  	 var writePointcells = objWritePointValues[i].getElementsByClassName("modbus-comp-table-cell");
			  
			  for (var l = 0; l <writePointcells.length; l++) { // 0 1 2 3
					 if( l==0 ){
						 writePointcells[l].innerText = writePtsArray[i].writePtName;
						 writePointcells[l].setAttribute("data",writePtsArray[i].writePtName);
						 writePointcells[l].setAttribute("title",writePtsArray[i].writePtName);
					 }
					 else if(l==1){
						 writePointcells[l].innerText = writePtsArray[i].writePtTypeValue;
						 writePointcells[l].setAttribute("data",writePtsArray[i].writePtTypeOrdinal);
						 writePointcells[l].setAttribute("title",writePtsArray[i].writePtTypeValue);
					 }			 
					 else if(l==2){
						 
						 writePointcells[l].setAttribute("data", writePtsArray[i].writePtAddress);					 
						 if(writePtsArray[i].writePtAddress.toString().toUpperCase().includes("0X")){
							 writePointcells[l].innerText = modbusUtil.showAddressInDecAndHexFromHex( writePtsArray[i].writePtAddress);
						 }else{
							 writePointcells[l].innerText = modbusUtil.showAddressInDecAndHex( writePtsArray[i].writePtAddress);
						 }
						 
					 }
					 else if(l==3){			 
						 writePointcells[l].innerText = writePtsArray[i].writePtSignificantChange;
						 writePointcells[l].setAttribute("data",writePtsArray[i].writePtSignificantChange); 
					 } 
					 else if(l==4){
						 writePointcells[l].innerText = writePtsArray[i].writePtDataFormatValue;
						 writePointcells[l].setAttribute("data",writePtsArray[i].writePtDataFormatOrdinal); 
					 }
					 else if(l==5){		 
						  var countStr= writePointRowId.substring(ModbusUtil.eighteenNumber),
						  count = Number(countStr);
						  var writePointTableCheckRowId = "checkBoxWritePoint"+count;						 
						  writePointcells[l].getElementsByTagName("input")[0].setAttribute("id",writePointTableCheckRowId);
					 } 
				  }  
		  
		  	  }				  

	  }	  
	  
	  ModbusWritePointsConfig.prototype.checkAllCheckBoxSelectedFromWriteTable = function(widget){
	  //If select all button is checked
	      var dom = widget.jq()
		  var writePointTableBody = this.getWritePointTableId(dom);
	      var writePointRows = writePointTableBody.find(".md-table-row");
		  var totalNoOfWritePts = writePointRows.length;
		  for (var i = 0; i <totalNoOfWritePts; i++) {
			  var writePointRowId = writePointRows[i].getAttribute("id");
			  var count= writePointRowId.substring(ModbusUtil.eighteenNumber),
			  count = Number(count);
			  var writePointTableCheckRowId = ModbusWritePointsConfig.checkBoxWritePoint+count;
			  if(dom.find(writePointTableCheckRowId).prop("checked") == false){
				  return false;
			  }	  
		  }		  
		  return true;
	  }
	  
	  ModbusWritePointsConfig.prototype.handleSelectAllCheckBoxStatusFromWritePointsTable= function(writePtRowChkBox,widget){
		  if($(writePtRowChkBox).prop("checked") == false){				  
			  $(ModbusWritePointsConfig.selectAllWritePtIdChkBox).prop("checked",false);			  
		     }else{
		    	 if(this.checkAllCheckBoxSelectedFromWriteTable(widget) == true)
	    		 {
	    		  $(ModbusWritePointsConfig.selectAllWritePtIdChkBox).prop("checked",true);		
	    		 }
	     }			  
		  }
	  
	  ModbusWritePointsConfig.prototype.selectAllCheckBoxFromWritePointsTable = function(widget){
	  //If select all button is checked
	      var dom = widget.jq()
		  var writePointTableBody = this.getWritePointTableId(dom);
	      var writePointRows = writePointTableBody.find(".md-table-row");
		  var totalNoOfWritePts = writePointRows.length;
		  var objWritePointValues = Object.assign({},writePointRows);
		  for (var i = 0; i <totalNoOfWritePts; i++) {
			  var writePointRowId = objWritePointValues[i].getAttribute("id");
			  var count= writePointRowId.substring(ModbusUtil.eighteenNumber),
			  count = Number(count);
			  var writePointTableCheckRowId = ModbusWritePointsConfig.checkBoxWritePoint+count;
			  if(dom.find(ModbusWritePointsConfig.selectAllWritePtIdChkBox).prop("checked") == true){
				  dom.find(writePointTableCheckRowId).prop("checked",true);
			  }else{
				  dom.find(writePointTableCheckRowId).prop("checked",false);
			  }		  
		  }			  
		//selected check box row will be deleted  
	  }
	  
	  
	  ModbusWritePointsConfig.prototype.validateWritePtAddressAndType = function(modBusPtsReadList,modBusPt,modBusPtsWriteList){
		  for(var i in modBusPtsWriteList){
			  
			  if(modBusPtsWriteList[i].rowIdJq == modBusPt.rowIdJq){
				  continue;
			  }
			  
			  if(modBusPtsWriteList[i].writePtAddress == modBusPt.writePtAddress){

				  if(modBusPtsWriteList[i].writePtTypeOrdinal == modBusPt.writePtTypeOrdinal){
					  var isErrorShown = modbusUtil.showErrorDiaogOnAddEditPointOnAdress(false,modBusPtsWriteList[i].writePtAddress,modBusPtsWriteList[i].writePtName);
					  return isErrorShown;
				  }
			  }
			  if(modBusPtsWriteList[i].writePtName === modBusPt.writePtName){
				  var isSameNameErrorShown = modbusUtil.showErrorDiaogOnAddEditPointSameName(false,modBusPt.writePtName);
				  return isSameNameErrorShown;
			  }
		  } 
		  
		  for(var j in modBusPtsReadList){
			  if(modBusPtsReadList[j].readPtName === modBusPt.writePtName){
				  var isSameNameErrorShownWritePt = modbusUtil.showErrorDiaogOnAddEditPointSameName(false,modBusPt.writePtName);
				  return isSameNameErrorShownWritePt;
			  } 
		  }
		  return false;	  
		  
	  }
	  
	  ModbusWritePointsConfig.prototype.showErrorDiaogOnAddEditWritePoint = function(significantChange,writePointAddress,writePointName){
		  
		  var significantChangeEmpty =  modbusUtil.checkStirngAsNullOrEmpty(significantChange);
		  var writePointAddressEmpty =  modbusUtil.checkStirngAsNullOrEmpty(writePointAddress)
		  var writePointNameEmpty =  modbusUtil.checkStirngAsNullOrEmpty(writePointName)
		  if(significantChangeEmpty == true || writePointAddressEmpty == true || writePointNameEmpty == true){
			  dialogs.showOk({
				  title: honIrmControlLex.get('honIrmControlLex.writepoint.add.edit.error.title'),
				  content: honIrmControlLex.get('honIrmControlLex.writepoint.add.edit.error'),
				  private: false
			   })
			 .ok(function (dlg) {
				    return true;
				  });
			 return true;
		  } 
		  
		  //writePt address hex or decimal and also the validation range will very
		  //check for read point address nan value
		  if(isNaN(writePointAddress)){
				 dialogs.showOk({
					  title: honIrmControlLex.get('honIrmControlLex.writepoint.add.edit.error.title'),
					  content: honIrmControlLex.get('honIrmControlLex.writepoint.add.edit.writePointAddressVal.nan.error'),
					  private: false
				     })
					  .ok(function () {
					    return true;
					  });
					
				 return true;
		  }
		  //check for limit value
		  if(writePointAddress.toString().toUpperCase().includes("0X")){
			  if(writePointAddress > 0xFFFF || writePointAddress < 0) {
					 dialogs.showOk({
						  title: honIrmControlLex.get('honIrmControlLex.writepoint.add.edit.error.title'),
						  content: honIrmControlLex.get('honIrmControlLex.writepoint.add.edit.writePointAddressVal.hex.limit.error'),
						  private: false
					     })
						  .ok(function () {
						    return true;
						  });
						
					 return true;
				  
			  }
		  }else{
			  if(writePointAddress > 65535 || writePointAddress < 0 ){
					 dialogs.showOk({
						  title: honIrmControlLex.get('honIrmControlLex.writepoint.add.edit.error.title'),
						  content: honIrmControlLex.get('honIrmControlLex.writepoint.add.edit.writePointAddressVal.dec.limit.error'),
						  private: false
					     })
						  .ok(function () {
						    return true;
						  });
						
					 return true;
				  
			  }
		  }
		  
	  }
	  
	  ModbusWritePointsConfig.prototype.getModbusDeleteWritePointTableData = function(widget) {

		  var deleteWritePointList = widget.deleteWritePointDataList;
		  var modbusDeviceOutputContentsObj = baja.$('baja:Component');
		  for (var key in deleteWritePointList) {
			  var modbusDeviceDeleteWritePtArgsObj = baja.$('honIrmControl:ModbusWritePointDisplayArgs');
			  //while adding add the slot name with escaping the special character but while showing to user unescape and show to user
			  modbusDeviceDeleteWritePtArgsObj.setWritePointName( baja.SlotPath.escape(deleteWritePointList[key].writePtName));
			  modbusDeviceDeleteWritePtArgsObj.setOldFb(deleteWritePointList[key].oldFb);
			  modbusDeviceDeleteWritePtArgsObj.setOldPointName(deleteWritePointList[key].oldPointName);
			  modbusDeviceDeleteWritePtArgsObj.setExistingSlotPath(deleteWritePointList[key].existingSlotPath);		  

			  //while adding add the slot name with escaping the special character but while showing to user unescape and show to user
			  modbusDeviceOutputContentsObj.add({
				    slot: modbusDeviceDeleteWritePtArgsObj.getWritePointName(),
				    value: modbusDeviceDeleteWritePtArgsObj
				  })
				  .then(function (prop) {
					})
				  .catch(function (err) {
					   baja.error(err);				      
				  });
			} 
		  
		  return modbusDeviceOutputContentsObj;
	  }
	  
	  
	  
	  ModbusWritePointsConfig.prototype.getModbusWritePointTableData = function(dom, widget) {

		  var writePointList = widget.writePointDataList;
		  var modbusDeviceOutputContentsObj = baja.$('baja:Component');
		  var ptNameArr = [];
		  for (var key in writePointList) {
			  var modbusDeviceWritePtArgsObj = baja.$('honIrmControl:ModbusWritePointDisplayArgs');
			  //while adding add the slot name with escaping the special character but while showing to user unescape and show to user
			  modbusDeviceWritePtArgsObj.setWritePointName( baja.SlotPath.escape(writePointList[key].writePtName));
			  ptNameArr.push(writePointList[key].writePtName);
			  var writePointTypeEnum = baja.DynamicEnum.make(parseInt(writePointList[key].writePtTypeOrdinal));
			  modbusDeviceWritePtArgsObj.setWritePointType(writePointTypeEnum);

			  if(writePointList[key].writePtAddress.toString().toUpperCase().includes("0X")){
				  modbusDeviceWritePtArgsObj.setWritePointAddress(parseInt(writePointList[key].writePtAddress.toString(),16));
			  }else{
				  modbusDeviceWritePtArgsObj.setWritePointAddress(writePointList[key].writePtAddress);  
			  }
			  
			  modbusDeviceWritePtArgsObj.setSignificantChange(writePointList[key].writePtSignificantChange);
			  var dataFormatTypeEnum = baja.DynamicEnum.make(parseInt(writePointList[key].writePtDataFormatOrdinal));
			  modbusDeviceWritePtArgsObj.setDataFormat(dataFormatTypeEnum);
			  modbusDeviceWritePtArgsObj.setOldFb(writePointList[key].oldFb);
			  modbusDeviceWritePtArgsObj.setOldPointName(writePointList[key].oldPointName);
			  modbusDeviceWritePtArgsObj.setExistingSlotPath(writePointList[key].existingSlotPath);		  

			  //while adding add the slot name with escaping the special character but while showing to user unescape and show to user
			  modbusDeviceOutputContentsObj.add({
				    slot: modbusDeviceWritePtArgsObj.getWritePointName(),
				    value: modbusDeviceWritePtArgsObj
				  })
				  .then(function (prop) {
					})
				  .catch(function (err) {
					   baja.error(err);				      
				  });
			} 
			for (var i = 0; i < ptNameArr.length; i++) { 
		   		   for(var j = i+1; j < ptNameArr.length; j++){
		   			   if(ptNameArr[i] === ptNameArr[j]){
		   				var isErrorShown = modbusUtil.showErrorDiaogOnAddEditPointSameName(true,ptNameArr[i]);
		   				if(isErrorShown == true){
		   					return true;
		   				}
		   			  }
		   		   }
		   		}
		  
		  return modbusDeviceOutputContentsObj;
	  }
	
	
	  return ModbusWritePointsConfig;
	
});


/**
 * A module defining `ModbusDeviceConfigView`.
 *
 * @module nmodule/honIrmControl/rc/ModbusDeviceConfigView
 */
define('nmodule/honIrmControl/rc/ModbusDeviceConfigView',['baja!',
	    'baja!honIrmControl:ModbusDevice',
	    'baja!honIrmControl:ModbusServerSideCallHandler',
	    'baja!honIrmControl:ModbusDeviceArgs',
	    'baja!honIrmControl:ModbusReadPoint',
	    'baja!honIrmControl:ModbusReadPointDisplayArgs',
	    'baja!honIrmControl:ModbusWritePoint',
	    'baja!honIrmControl:ModbusWritePointDisplayArgs',
        'bajaux/mixin/subscriberMixIn',
        'bajaux/util/SaveCommand',
        'bajaux/Widget',
        'css!nmodule/honIrmControl/rc/css/irmnx-styles',
        'css!nmodule/honIrmControl/rc/css/comp-table',
        'hbs!nmodule/honIrmControl/rc/templates/modbusDeviceView',
        'hbs!nmodule/honIrmControl/rc/templates/modbusReadPointDialog',
        'hbs!nmodule/honIrmControl/rc/templates/modbusWritePointDialog',
        'nmodule/honIrmControl/rc/ModbusReadPointsConfig',
        'nmodule/honIrmControl/rc/ModbusWritePointsConfig',
        'nmodule/honIrmControl/rc/ModbusUtil',
        'jquery',
        'dialogs',
        'lex!honIrmControl', 
        'Promise'], function ( 
        baja,
        ModbusDevice,
        ModbusServerSideCallHandler,
        ModbusDeviceArgs,
        ModbusReadPoint,
        ModbusReadPointDisplayArgs,
        ModbusWritePoint,
        ModbusWritePointDisplayArgs,
        subscriberMixIn,
        SaveCommand,
        Widget,
        css,
        tablecss,
        template,
        templateReadPointDialog,
        modbusWritePointDialog,
        ModbusReadPointsConfig,
        ModbusWritePointsConfig,
        ModbusUtil,
        $,
        dialogs,
        lexicons, //---------------------------------------------------------- *NEW*
        Promise) {

  
  
  
  
    var honIrmControlLex = lexicons[0];
 
    var modbusReadPointsConfig = new ModbusReadPointsConfig();
    var modbusUtil = new ModbusUtil();
    var modbusWritePointsConfig = new ModbusWritePointsConfig();
  
    var deviceAddress = "DeviceAddress",
    byteOrder = "ByteOrder",
    maxReadPointsCount = "MaxReadPointCount",
    readPtOperationMode ="readPtOperationMode";
   

    
	function getModBusDeviceName() {									
		return $('#deviceNameLabelId');
	}
    
	function getModBusDeviceAddress() {									
		return  $('#devAddressId');
	}
	
	function getModBusDeviceByteOrder() {		
		return $('#byteOrderId');
	}
	
	function getModBusDevicePointCount() {		
		return $('#maxReadPointsCountId');
	}
	
	function setModBusDeviceReadWritePointCount(isRead,count) {		
		if(isRead == true){
			$('#readPointCountId').text(count);
		}else{
			$('#writePointCountId').text(count);
		}
	}

	//dialog read points-------------------
	function getReadPointTypeOnDialogId(dom) {									
		return dom.find('#readPointTypeDialogId');
	}
    
	function getOperationModeDialogId(dom) {									
		return dom.find('#readPointOperationModeDialogId');
	}
	
	function getDataFormatDialogId(dom) {		
		return dom.find('#dataFormatDialogId');
	}
	
	function getScalingFactorDialogId(dom) {		
		return dom.find('#scalingFactorDialogId');
	}
	
	function getReadPointAddressDialogId(dom) {		
		return dom.find('#readPointAddressDialogId');
	}
	
	function getReadPointNameDialogId(dom) {		
		return dom.find('#readPointNameDialogId');
	}
	
	function getReadPointEventBitMaskingDialogId(dom) {		
		return dom.find('#eventBitMaskingDialogId');
	}
	
	//dialog write points-------------------
	function getWritePointTypeOnDialogId(dom) {									
		return dom.find('#writePointTypeDialogId');
	}
	function getWritePointDataFormatDialogId(dom) {		
		return dom.find('#writePointDataFormatDialogId');
	}
	
	function getSignificantChangeDialogId(dom) {		
		return dom.find('#significantChangeDialogId');
	}
	
	function getWritePointAddressDialogId(dom) {		
		return dom.find('#writePointAddressDialogId');
	}
	
	function getWritePointNameDialogId(dom) {		
		return dom.find('#writePointNameDialogId');
	}
	
	function getReadPointTableFromDocument() {		
		return document.getElementById("readPointTableBodyId");
	}
	
	function getWritePointTableFromDocument() {		
		return document.getElementById("writePointTableBodyId");
	}
	
	function getReadPtPollTimeDialogId(dom) {		
		return dom.find('#readPointPollTimeDialogId');
	}
	
	function getReadPtPollTimeLabelId(dom) {									
		return dom.find('#readPointPollTimeLabelId');
	}
	function getReadPtPollTimeRangeLabelId(dom) {	
		return dom.find('#readPointPollTimeRangeLabelId');	
	}
		
	function loadModBusByteOrderInView(modbusDevByteOrderDom,modbusDevicePropResult) {
		var modbusDeviceObj = baja.$('honIrmControl:ModbusDevice');
		var byteOrderArrOrdinal = modbusDeviceObj.getByteOrder().$map.$map.valueFacets.$val.get("range").getOrdinals();
		var option = '';
		for (var i=0;i<byteOrderArrOrdinal.length;i++){
			var optionByteOrderVal =  modbusDeviceObj.getByteOrder().$map.$map.valueFacets.$val.get("range").getTag(byteOrderArrOrdinal[i]);
			option += '<option value="'+ byteOrderArrOrdinal[i] + '">' + optionByteOrderVal + '</option>';
		}
		modbusDevByteOrderDom.append(option);
		modbusDevByteOrderDom.val(modbusDevicePropResult.get(byteOrder).$ordinal.toString());
	}
	
	
	function loadModBusPointCountInView(modbusDevReadPointCountDom,modbusDevicePropResult) {									
		modbusDevReadPointCountDom.val(modbusDevicePropResult.get(maxReadPointsCount).$val);
	}
	
	function loadModBusModBusDeviceAddressInView(modbusDevAddressDom,modbusDevicePropResult) {									
		modbusDevAddressDom.val(modbusDevicePropResult.get(deviceAddress).$val);
	}

	
  /**
	 * Description of your widget.
	 * 
	 * @class
	 * @extends module:nmodule/webEditors/rc/fe/baja/BaseEditor
	 * @alias module:nmodule/honIrmControl/rc/ModbusDeviceConfigView
	 */
	var ModbusDeviceConfigView = function () {
	      Widget.apply(this, arguments);
	      subscriberMixIn(this);
	      this.readPointDataList = {};
	      this.writePointDataList = {};
	      //list contains the points that will be deleted from stations
	      this.deleteReadPointDataList = {};
	      this.deleteWritePointDataList = {};
	    // Add a Save Command to allow the user to save the `Widget`.
	    this.getCommandGroup().add(new SaveCommand());
	    this.readPtOperationModeOrdinals;
	    this.readPtOperationModeRange;
	  };
	  ModbusDeviceConfigView.prototype = Object.create(Widget.prototype);
	  ModbusDeviceConfigView.prototype.constructor = ModbusDeviceConfigView;
	  
	  ModbusDeviceConfigView.prototype.tabHandler = function (evt, tabName) {
		  var i, tabcontent, tabModbusBtn;
		  tabcontent = document.getElementsByClassName("tabcontent");
		  for (i = 0; i < tabcontent.length; i++) {
			tabcontent[i].style.display = "none";
		  }
		  tabModbusBtn = document.getElementsByClassName("tablinks");
		  for (i = 0; i < tabModbusBtn.length; i++) {
			  if(tabModbusBtn[i].className != evt.currentTarget.className){
			  tabModbusBtn[i].className = tabModbusBtn[i].className.replace(" active", " Inactive");
			  }else{
				  tabModbusBtn[i].className = tabModbusBtn[i].className.replace(" active", "");
				  tabModbusBtn[i].className = tabModbusBtn[i].className.replace(" Inactive", "");
			  }
			  
		  }
		  document.getElementById(tabName).style.display = "block";
		  evt.currentTarget.className += " active";			  
		};
	  
	  ModbusDeviceConfigView.prototype.attachTabEvents = function(dom) {
           var that = this;
           dom.find("div.button-cover").on('click', 'button',
               function(event){
                   try{
                	   var tabName = $(event.target).attr("data-tabname");                	   
                       that.tabHandler(event, tabName);
                       event.preventDefault();
                   }catch(error){
                       //Baja.error(error);
                       event.preventDefault();
                   }
               });         
       };
	  

  /**
   * Describe how your widget does its initial setup of the DOM.
   *
   * @param {jQuery} element the DOM element into which to load this widget
   */
  ModbusDeviceConfigView.prototype.doInitialize = function (dom) {
	  var widget = this;
	    // The template function returns the contents of modbusDeviceView.hbs, but with
	    // variables like {{value}} filled in using the properties of the object
	    // argument.
	    dom.html(template({ //------------------------------------------------ *NEW*
	      deviceNameLabel: honIrmControlLex.get('honIrmControlLex.deviceName.label'),
	      DeviceAddress: honIrmControlLex.get('honIrmControlLex.deviceAddress.label'),
	      ByteOrder: honIrmControlLex.get('honIrmControlLex.byteOrder.label'),
	      MaxReadPointsCount: honIrmControlLex.get('honIrmControlLex.maxReadPointsCount.label'),
	      MaxReadPointsCountRange: honIrmControlLex.get('honIrmControlLex.modbus.device.readPoint.range'),
	      DeviceAddressRange: honIrmControlLex.get('honIrmControlLex.modbus.device.address.range'),
	      //colum name read pt
	      ReadPointsCount: honIrmControlLex.get('honIrmControlLex.modbus.device.readPoint.count'),	
	      ReadPointName: honIrmControlLex.get('honIrmControlLex.readpoint.name.label'),
	      ReadPointType: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointType.label'),
	      ReadPointAddress: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointAddress.label'),
	      ReadPointOperationMode: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointOperationMode.label'),
	      ReadPointPollTime: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointPollTime.label'),
	      ScalingFactor: honIrmControlLex.get('honIrmControlLex.readpoint.ScalingFactor.label'),
	      ReadDataFormat: honIrmControlLex.get('honIrmControlLex.readpoint.DataFormat.label'),
	      EventBitMasking: honIrmControlLex.get('honIrmControlLex.readpoint.EventBitMasking.label'),
	      //colum name write pt
	      WritePointsCount: honIrmControlLex.get('honIrmControlLex.modbus.device.writePoint.count'),	
	      WritePointName: honIrmControlLex.get('honIrmControlLex.writepoint.WritePointName.label'),
	      WritePointType: honIrmControlLex.get('honIrmControlLex.writepoint.WritePointType.label'),
	      WritePointAddress: honIrmControlLex.get('honIrmControlLex.writepoint.WritePointAddress.label'),
	      SignificantChange: honIrmControlLex.get('honIrmControlLex.writepoint.SignificantChange.label'),
	      WriteDataFormat: honIrmControlLex.get('honIrmControlLex.writepoint.WriteDataFormat.label'),
	      
	      
	    }));

	    // When the user makes a change, mark the `Widget` as modified using
	    // setModified(true).
	    dom.on('input', '.form-element', function () {
	      widget.setModified(true);
	    }); 
	    dom.on('select', '.form-element', function () {
		      widget.setModified(true);
		    });
	    widget.attachTabEvents(dom);
	    $("#pointReadTabId").css('display', 'block');
	    $("#pointWriteTabId").css('display', 'none');
		   
  };

  /**
   * Describe how your widget loads in a value.
   *
   * @param value description of the value to be loaded into this widget
   */
  ModbusDeviceConfigView.prototype.doLoad = function (modbusDevice) {
	  var widget = this;
	  var dom = widget.jq();
	  createModbusOverviewContent(modbusDevice, widget);
	  loadModbusReadPointsContent(modbusDevice, widget);
	  loadModbusWritePointsContent(modbusDevice, widget);
	  //capturing events on add and delete of readPoints ,write points
	  addModbusReadPointDialog(widget);
	  addModbusWritePointDialog(widget);
	  deleteModbusReadPoints(widget);
	  deleteModbusWritePoints(widget);
	  
	  
	  var param = {
		    	mainView:widget
	   };	
	  dom.on("change", ModbusReadPointsConfig.selectAllReadPtIdChkBox,param,function(event){
	     event.preventDefault();
	     modbusReadPointsConfig.selectAllCheckBoxFromReadPointsTable(event.data.mainView);
	  }); 
	  dom.on("change", ModbusWritePointsConfig.selectAllWritePtIdChkBox,param,function(event){
		 event.preventDefault();
		 modbusWritePointsConfig.selectAllCheckBoxFromWritePointsTable(event.data.mainView);
	  }); 
	  
	  dom.on("click", "#readPtAddressCellId",param,function(event){
		     event.preventDefault();
		     clearFilterIcon("#sortReadPtNameIconId",event.data.mainView);  //sortReadPtNameIconId  sortReadPtAddressIconId
		     clearFilterIcon("#sortReadPtTypeIconId",event.data.mainView);
		     clearFilterIcon("#sortReadPtOperationModeIconId",event.data.mainView);
		     if(ModbusReadPointsConfig.activeFilterReadPts === ModbusReadPointsConfig.readPtAddressFilterDsc){
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtAddressFilterAsc;
		    	 applyFilterIcon("#sortReadPtAddressIconId","Asc",event.data.mainView);
		    	 
		     }else if(ModbusReadPointsConfig.activeFilterReadPts === ModbusReadPointsConfig.readPtAddressFilterAsc){
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtAddressFilterDsc;
		    	 applyFilterIcon("#sortReadPtAddressIconId","Dsc",event.data.mainView);
		     }else{
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtAddressFilterAsc;
		    	 applyFilterIcon("#sortReadPtAddressIconId","Asc",event.data.mainView);
		     }
		     modbusReadPointsConfig.sortReadTableOnSelectedFilter(event.data.mainView,ModbusReadPointsConfig.activeFilterReadPts);

		}); 
	  
	  dom.on("click", "#readPtNameCellId",param,function(event){
		     event.preventDefault();
		     clearFilterIcon("#sortReadPtAddressIconId",event.data.mainView);
		     clearFilterIcon("#sortReadPtTypeIconId",event.data.mainView);
		     clearFilterIcon("#sortReadPtOperationModeIconId",event.data.mainView);
		     if(ModbusReadPointsConfig.activeFilterReadPts === ModbusReadPointsConfig.readPtNameFilterDsc){
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtNameFilterAsc;
		    	 applyFilterIcon("#sortReadPtNameIconId","Asc",event.data.mainView);
		    	 
		     }else if(ModbusReadPointsConfig.activeFilterReadPts === ModbusReadPointsConfig.readPtNameFilterAsc){
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtNameFilterDsc;
		    	 applyFilterIcon("#sortReadPtNameIconId","Dsc",event.data.mainView);
		     }else{
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtNameFilterAsc;
		    	 applyFilterIcon("#sortReadPtNameIconId","Asc",event.data.mainView);
		     }
		     modbusReadPointsConfig.sortReadTableOnSelectedFilter(event.data.mainView,ModbusReadPointsConfig.activeFilterReadPts);

		});
	  
	  dom.on("click", "#readPtTypeCellId",param,function(event){
		     event.preventDefault();
		     clearFilterIcon("#sortReadPtAddressIconId",event.data.mainView);
		     clearFilterIcon("#sortReadPtNameIconId",event.data.mainView);
		     clearFilterIcon("#sortReadPtOperationModeIconId",event.data.mainView);
		     
		     if(ModbusReadPointsConfig.activeFilterReadPts === ModbusReadPointsConfig.readPtTypeFilterDsc){
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtTypeFilterAsc;
		    	 applyFilterIcon("#sortReadPtTypeIconId","Asc",event.data.mainView);
		    	 
		     }else if(ModbusReadPointsConfig.activeFilterReadPts === ModbusReadPointsConfig.readPtTypeFilterAsc){
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtTypeFilterDsc;
		    	 applyFilterIcon("#sortReadPtTypeIconId","Dsc",event.data.mainView);
		     }else{
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtTypeFilterAsc;
		    	 applyFilterIcon("#sortReadPtTypeIconId","Asc",event.data.mainView);
		     }
		     modbusReadPointsConfig.sortReadTableOnSelectedFilter(event.data.mainView,ModbusReadPointsConfig.activeFilterReadPts);

		});
	  
	  
	  dom.on("click", "#readPtOperationModeCellId",param,function(event){
		     event.preventDefault();
		     clearFilterIcon("#sortReadPtAddressIconId",event.data.mainView);
		     clearFilterIcon("#sortReadPtTypeIconId",event.data.mainView);
		     clearFilterIcon("#sortReadPtNameIconId",event.data.mainView);
		     
		     if(ModbusReadPointsConfig.activeFilterReadPts === ModbusReadPointsConfig.readPtOperationModeFilterDsc){
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtOperationModeFilterAsc;
		    	 applyFilterIcon("#sortReadPtOperationModeIconId","Asc",event.data.mainView);
		    	 
		     }else if(ModbusReadPointsConfig.activeFilterReadPts === ModbusReadPointsConfig.readPtOperationModeFilterAsc){
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtOperationModeFilterDsc;
		    	 applyFilterIcon("#sortReadPtOperationModeIconId","Dsc",event.data.mainView);
		     }else{
		    	 ModbusReadPointsConfig.activeFilterReadPts = ModbusReadPointsConfig.readPtOperationModeFilterAsc;
		    	 applyFilterIcon("#sortReadPtOperationModeIconId","Asc",event.data.mainView);
		     }
		     modbusReadPointsConfig.sortReadTableOnSelectedFilter(event.data.mainView,ModbusReadPointsConfig.activeFilterReadPts);

		});
	  
	  
	  
	  dom.on("click", "#writePtAddressCellId",param,function(event){
		     event.preventDefault();
		     clearFilterIcon("#sortWritePtNameIconId",event.data.mainView);  //sortReadPtNameIconId  sortReadPtAddressIconId
		     //sortReadPtNameIconId  sortReadPtAddressIconId
		     clearFilterIcon("#sortWritePtTypeIconId",event.data.mainView); 
		     if(ModbusWritePointsConfig.activeFilterWritePts === ModbusWritePointsConfig.writePtAddressFilterDsc){
		    	 ModbusWritePointsConfig.activeFilterWritePts = ModbusWritePointsConfig.writePtAddressFilterAsc;
		    	 applyFilterIcon("#sortWritePtAddressIconId","Asc",event.data.mainView);
		    	 
		     }else if(ModbusWritePointsConfig.activeFilterWritePts === ModbusWritePointsConfig.writePtAddressFilterAsc){
		    	 ModbusWritePointsConfig.activeFilterWritePts = ModbusWritePointsConfig.writePtAddressFilterDsc;
		    	 applyFilterIcon("#sortWritePtAddressIconId","Dsc",event.data.mainView);
		     }else{
		    	 ModbusWritePointsConfig.activeFilterWritePts = ModbusWritePointsConfig.writePtAddressFilterAsc;
		    	 applyFilterIcon("#sortWritePtAddressIconId","Asc",event.data.mainView);
		     }
		     modbusWritePointsConfig.sortWriteTableOnSelectedFilter(event.data.mainView,ModbusWritePointsConfig.activeFilterWritePts);

		}); 
	  
	  dom.on("click", "#writePtNameCellId",param,function(event){
		     event.preventDefault();
		     clearFilterIcon("#sortWritePtAddressIconId",event.data.mainView);
		     clearFilterIcon("#sortWritePtTypeIconId",event.data.mainView); 
		     if(ModbusWritePointsConfig.activeFilterWritePts === ModbusWritePointsConfig.writePtNameFilterDsc){
		    	 ModbusWritePointsConfig.activeFilterWritePts = ModbusWritePointsConfig.writePtNameFilterAsc;
		    	 applyFilterIcon("#sortWritePtNameIconId","Asc",event.data.mainView);
		    	 
		     }else if(ModbusWritePointsConfig.activeFilterWritePts === ModbusWritePointsConfig.writePtNameFilterAsc){
		    	 ModbusWritePointsConfig.activeFilterWritePts = ModbusWritePointsConfig.writePtNameFilterDsc;
		    	 applyFilterIcon("#sortWritePtNameIconId","Dsc",event.data.mainView);
		     }else{
		    	 ModbusWritePointsConfig.activeFilterWritePts = ModbusWritePointsConfig.writePtNameFilterAsc;
		    	 applyFilterIcon("#sortWritePtNameIconId","Asc",event.data.mainView);
		     }
		     modbusWritePointsConfig.sortWriteTableOnSelectedFilter(event.data.mainView,ModbusWritePointsConfig.activeFilterWritePts);

		}); 
	  
	  dom.on("click", "#writePtTypeCellId",param,function(event){
		     event.preventDefault();
		     clearFilterIcon("#sortWritePtAddressIconId",event.data.mainView);
		     clearFilterIcon("#sortWritePtNameIconId",event.data.mainView); 
		     if(ModbusWritePointsConfig.activeFilterWritePts === ModbusWritePointsConfig.writePtTypeFilterDsc){
		    	 ModbusWritePointsConfig.activeFilterWritePts = ModbusWritePointsConfig.writePtTypeFilterAsc;
		    	 applyFilterIcon("#sortWritePtTypeIconId","Asc",event.data.mainView);
		    	 
		     }else if(ModbusWritePointsConfig.activeFilterWritePts === ModbusWritePointsConfig.writePtTypeFilterAsc){
		    	 ModbusWritePointsConfig.activeFilterWritePts = ModbusWritePointsConfig.writePtTypeFilterDsc;
		    	 applyFilterIcon("#sortWritePtTypeIconId","Dsc",event.data.mainView);
		     }else{
		    	 ModbusWritePointsConfig.activeFilterWritePts = ModbusWritePointsConfig.writePtTypeFilterAsc;
		    	 applyFilterIcon("#sortWritePtTypeIconId","Asc",event.data.mainView);
		     }
		     modbusWritePointsConfig.sortWriteTableOnSelectedFilter(event.data.mainView,ModbusWritePointsConfig.activeFilterWritePts);

		}); 

  };
  
   function applyFilterIcon(id,sortType,widget)
   {
	   var dom = widget.jq();
	   
	   if(sortType === "Asc")
	   {
		   dom.find(id).html("&#9650;");
	   }
	   else if(sortType === "Dsc")
	   {
	      dom.find(id).html("&#9660;");
	   }	   
   }
   
   function clearFilterIcon(id,widget)
   {
	   var dom = widget.jq();
	   dom.find(id).text("");	   
   }
  
  
  function deleteModbusReadPoints(widget){  
	   var dom = widget.jq();
	    var param = {
		    	mainView:widget
		     };	    
	    dom.on('click', "#deleteButtonReadPointId",
	    		 param,
	    		 function (event) 
	          {      	
	    	   event.preventDefault();
	    	   var mainView = event.data.mainView;
	    	   deleteSelectedReadPointsFromTableAndShowWarning(mainView);
			  });	  
     }
   
  function deleteSelectedReadPointsFromTableAndShowWarning(widget){
	  // If select all button is checked
      var dom = widget.jq()
	  var readPointTableBody = modbusReadPointsConfig.getReadPointTableId(dom);
	  var readPointRows = readPointTableBody.find(".md-table-row");
	  var totalNoOfReadPts = readPointRows.length;
	  var objReadPointValues = Object.assign({},readPointRows);
	  var anyChkBoxNotSelected = true;
	  
	  if($("#selecetAllReadPtIdChkBox").prop("checked") == true){
		  if(totalNoOfReadPts > 0){
	             showDeleteWarningDialogAndPtsTobeDeleted(true,widget);
	             anyChkBoxNotSelected = false;  
		   }
		  }
	   else{
			// selected check box row will be deleted
			  for (var j = 0; j <totalNoOfReadPts; j++) {
				  var readPointRowId = objReadPointValues[j].getAttribute("id");
		    	  var count= readPointRowId.substring(ModbusUtil.seventeenNumber),
		    	  count = Number(count);
				  var readPointTableCheckRowId = ModbusReadPointsConfig.checkBoxReadPoint+count;
				  var readPointTableRowId = "#"+readPointRowId;
				  if($(readPointTableCheckRowId).prop("checked") == true){
					 showDeleteWarningDialogAndPtsTobeDeleted(true,widget);
					 anyChkBoxNotSelected = false;
					 break;
				  }
			  }	
		  }
	  if(anyChkBoxNotSelected == true){
		  modbusUtil.showWarningDialogAndPtsTobeDeleted(true);
	  }
	 }	
  
  
  function deleteSelectedReadPointsFromTable(widget){
	  // If select all button is checked
      var dom = widget.jq()
	  var readPointTableBody = modbusReadPointsConfig.getReadPointTableId(dom);
	  var readPointRows = readPointTableBody.find(".md-table-row");
	  var totalNoOfReadPts = readPointRows.length;
	  var objReadPointValues = Object.assign({},readPointRows);
	  if($("#selecetAllReadPtIdChkBox").prop("checked") == true){		  
		  for (var i = 0; i <totalNoOfReadPts; i++) {
			  var readPointRowId = objReadPointValues[i].getAttribute("id");
			  var readPointTableRowId = "#"+readPointRowId;
			  $( readPointTableRowId).remove();
			  widget.setModified(true);
		    }
		  //before deleting put the item in deleted list if OldFb is true
		  for (var key in  widget.readPointDataList) {
		   if(widget.readPointDataList[key].oldFb == true){
			  widget.deleteReadPointDataList[key] = widget.readPointDataList[key];
		    }
		  }
		  widget.readPointDataList = {};
		  //once the delete action is done then we should de select the selectAll checkbox
		  $("#selecetAllReadPtIdChkBox").prop("checked",false);
		  }
	   else{
			// selected check box row will be deleted
			  for (var j = 0; j <totalNoOfReadPts; j++) {
				  var readPointRowId = objReadPointValues[j].getAttribute("id");
		    	  var count= readPointRowId.substring(ModbusUtil.seventeenNumber),
		    	  count = Number(count);
				  var readPointTableCheckRowId = ModbusReadPointsConfig.checkBoxReadPoint+count;
				  var readPointTableRowId = "#"+readPointRowId;
				  if($(readPointTableCheckRowId).prop("checked") == true){
					  var deleteChkBoxId = "checkBoxReadPoint"+count;
					  //before deleting put the item in deleted list if OldFb is true
					  if(widget.readPointDataList[deleteChkBoxId].oldFb == true){
						  widget.deleteReadPointDataList[deleteChkBoxId] = widget.readPointDataList[deleteChkBoxId];
					  }
					  delete widget.readPointDataList[deleteChkBoxId]; 
					  
					  $( readPointTableRowId).remove();
					  widget.setModified(true);
				  }
			  }	
		  }
	  setModBusDeviceReadWritePointCount(true,Object.keys(widget.readPointDataList).length);
	 }	
  
  function deleteModbusWritePoints(widget){  
	   var dom = widget.jq();
	    var param = {
		    	mainView:widget
		     };	    
	    dom.on('click', "#deleteButtonWritePointId",
	    		 param,
	    		 function (event) 
	          {      	
	    	   event.preventDefault();
	    	   var mainView = event.data.mainView;
	    	   deleteSelectedWritePointsFromTableAndShowWarning(mainView);
		});	  
    }
  
 function deleteSelectedWritePointsFromTable(widget){
	  // If select all button is checked
     var dom = widget.jq()
	  var writePointTableBody = modbusWritePointsConfig.getWritePointTableId(dom);
	  var writePointRows = writePointTableBody.find(".md-table-row");
	  var totalNoOfWritePts = writePointRows.length;
	  var objWritePointValues = Object.assign({},writePointRows);
	  if($("#selecetAllWritePtIdChkBox").prop("checked") == true){		  
		  for (var i = 0; i <totalNoOfWritePts; i++) {
			  var writePointRowId = objWritePointValues[i].getAttribute("id");
			  var writePointTableRowId = "#"+writePointRowId;
			  $( writePointTableRowId).remove();
			  widget.setModified(true);
		    }
		  //before deleting put the item in deleted list if OldFb is true and it will be sent to serverside call
		  for (var key in  widget.writePointDataList) {
		     if(widget.writePointDataList[key].oldFb == true) {
			    widget.deleteWritePointDataList[key] = widget.writePointDataList[key];
		     }
		   }
		  widget.writePointDataList = {};
		  //once the delete action is done then we should de select the selectAll checkbox
		  $("#selecetAllWritePtIdChkBox").prop("checked",false);
		  }
	   else{
			// selected check box row will be deleted
			  for (var j = 0; j <totalNoOfWritePts; j++) {
				  var writePointRowId = objWritePointValues[j].getAttribute("id");
		    	  var count= writePointRowId.substring(ModbusUtil.eighteenNumber),
		    	  count = Number(count);
				  var writePointTableCheckRowId = ModbusWritePointsConfig.checkBoxWritePoint+count;
				  var writePointTableRowId = "#"+writePointRowId;
				  if($(writePointTableCheckRowId).prop("checked") == true){
					  var deleteChkBoxId = "checkBoxWritePoint"+count;
					  //before deleting put the item in deleted list if OldFb is true and it will be sent to serverside call
					  if(widget.writePointDataList[deleteChkBoxId].oldFb == true){
						  widget.deleteWritePointDataList[deleteChkBoxId] = widget.writePointDataList[deleteChkBoxId];
					  }
					  delete widget.writePointDataList[deleteChkBoxId]; 
					  $( writePointTableRowId).remove();
					  widget.setModified(true);
				  }
			  }	
		  }
	  setModBusDeviceReadWritePointCount(false,Object.keys(widget.writePointDataList).length);
	  
	 }
 
 function deleteSelectedWritePointsFromTableAndShowWarning(widget){
	  // If select all button is checked
    var dom = widget.jq()
	  var writePointTableBody = modbusWritePointsConfig.getWritePointTableId(dom);
	  var writePointRows = writePointTableBody.find(".md-table-row");
	  var totalNoOfWritePts = writePointRows.length;
	  var objWritePointValues = Object.assign({},writePointRows);
	  var anyChkBoxNotSelected = true;
	  if($("#selecetAllWritePtIdChkBox").prop("checked") == true){
		  if(totalNoOfWritePts > 0){
				 showDeleteWarningDialogAndPtsTobeDeleted(false,widget);
				 anyChkBoxNotSelected = false;  
		   }
		  }
	   else{
			// selected check box row will be deleted
			  for (var j = 0; j <totalNoOfWritePts; j++) {
				  var writePointRowId = objWritePointValues[j].getAttribute("id");
		    	  var count= writePointRowId.substring(ModbusUtil.eighteenNumber),
		    	  count = Number(count);
				  var writePointTableCheckRowId = ModbusWritePointsConfig.checkBoxWritePoint+count;
				  var writePointTableRowId = "#"+writePointRowId;
				  if($(writePointTableCheckRowId).prop("checked") == true){
					showDeleteWarningDialogAndPtsTobeDeleted(false,widget);
					anyChkBoxNotSelected = false;
					break;
				  }
			  }	
		  }
	  
	  if(anyChkBoxNotSelected == true){
		  modbusUtil.showWarningDialogAndPtsTobeDeleted(false);
	   }	  
	 }

 function showDeleteWarningDialogAndPtsTobeDeleted(ptTypeRead,widget){
		 dialogs.showOkCancel({
			  title:ptTypeRead == true ?honIrmControlLex.get('honIrmControlLex.readpoint.add.edit.error.title'):honIrmControlLex.get('honIrmControlLex.writepoint.add.edit.error.title'),
			  content:ptTypeRead == true ?honIrmControlLex.get('honIrmControlLex.readpoint.delete'):honIrmControlLex.get('honIrmControlLex.writepoint.delete'),
			  private: false	  
		       })
			 .ok(function () {
			    if(ptTypeRead == true ){
			    	deleteSelectedReadPointsFromTable(widget);
			    }else{
			    	deleteSelectedWritePointsFromTable(widget);
			    }
			  }).cancel(function () {
				  return true;
			  });
     }
 
  function addModbusWritePointDialog(widget){  
	  var addDialogDom;
	  var modbusDeviceWritePtObj = baja.$('honIrmControl:ModbusWritePoint');
	  
	  $( "#addButtonWritePointId" ).click(function(event) {
			 //create dialog
			  event.preventDefault();
			  dialogs.showOkCancel({
			         title: honIrmControlLex.get('honIrmControlLex.add.writepoint.dialog.title.label'),
			         content: function(dlg, dlgAddWritePtJq) {
			        	 dlgAddWritePtJq.html(modbusWritePointDialog({
			            	 //lexicon text goes here
			        		 WritePointName: honIrmControlLex.get('honIrmControlLex.writepoint.WritePointName.label'),
			        		 WritePointType: honIrmControlLex.get('honIrmControlLex.writepoint.WritePointType.label'),
			        		 WritePointAddressDialog: honIrmControlLex.get('honIrmControlLex.writepoint.WritePointAddress.label'),
			        		 pointAddressRange:honIrmControlLex.get('honIrmControlLex.modbus.writepoint.address.range'),
			        		 SignificantChange: honIrmControlLex.get('honIrmControlLex.writepoint.SignificantChange.label'),
			        		 WritePointDataFormat: honIrmControlLex.get('honIrmControlLex.writepoint.WriteDataFormat.label'),
			             }));
			             //populate the data in add dialog 
			        	 //write Point type
			            var writePointTypeAddDialogId = getWritePointTypeOnDialogId(dlgAddWritePtJq);
			     		var optionPtType = '',
			     		writePtTypeOrdinals = modbusDeviceWritePtObj.getWritePointType().$map.$map.valueFacets.$val.get("range").getOrdinals();
			    		for (var i=0;i<writePtTypeOrdinals.length;i++){		
			    				var optionPointTypeVal =  modbusDeviceWritePtObj.getWritePointType().$map.$map.valueFacets.$val.get("range").getTag(writePtTypeOrdinals[i]);
			    				optionPtType += '<option value="'+ writePtTypeOrdinals[i] + '">' + optionPointTypeVal + '</option>';
			    		}
			    		writePointTypeAddDialogId.append(optionPtType);
			    		writePointTypeAddDialogId.val(writePtTypeOrdinals[0].toString());
			           
			    		//data format
			            var writePointDataFormatAddDialogId = getWritePointDataFormatDialogId(dlgAddWritePtJq);
			     		var optionDataFormat = '',
			     		writePtDataFormatOrdinals = modbusDeviceWritePtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getOrdinals();
			    		for (var k=0;k<writePtDataFormatOrdinals.length;k++){		
			    				var optionPointDataFormatVal =  modbusDeviceWritePtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getTag(writePtDataFormatOrdinals[k]);
			    				optionDataFormat += '<option value="'+ writePtDataFormatOrdinals[k] + '">' + optionPointDataFormatVal + '</option>';
			    		}
			    		writePointDataFormatAddDialogId.append(optionDataFormat);
			    		writePointDataFormatAddDialogId.val(writePtDataFormatOrdinals[0].toString());
			    		addDialogDom = dlgAddWritePtJq;
			             },
			         private: false //ensures background contents are screened when the dialog is showing
			       })
			       .ok(function (dlg) {
			    	var isErrorShown = addRowToWritePointTableOnAdd(addDialogDom,modbusDeviceWritePtObj,widget,dlg);
			    	 if(isErrorShown == true){
			    		 return false;
			    	 }
                   widget.setModified(true);
			       })
			       .cancel(function (dlg) {
			    	   return true;
				    });
	
			});  
     }

  function handleModbusReadPointOperationTypeEventDialog(dlgReadPtJq,isAdd){   
	  dlgReadPtJq.on("change", "#readPointOperationModeDialogId",function(event){
		  hideShowPollTimeFields(dlgReadPtJq);
		});
  
  }
  
  function hideShowPollTimeFields(dlgReadPtJq){
	  var readPointOperationModeDialogId = getOperationModeDialogId(dlgReadPtJq);
	  var readPointPollTimeLabelId = getReadPtPollTimeLabelId(dlgReadPtJq);
	  var readPointPollTimeDialogId = getReadPtPollTimeDialogId(dlgReadPtJq);
	  var readPointPollTimeRangeDialogId = getReadPtPollTimeRangeLabelId(dlgReadPtJq);
	  if(readPointOperationModeDialogId.val() == ModbusReadPointsConfig.userDefinedMode){
		  readPointPollTimeLabelId.show();
		  readPointPollTimeDialogId.show();
		  readPointPollTimeRangeDialogId.show();
		  readPointPollTimeDialogId.val(60);
		  
	  }else{
		  readPointPollTimeLabelId.hide();
		  readPointPollTimeDialogId.hide();
		  readPointPollTimeRangeDialogId.hide();
		  readPointPollTimeDialogId.val(0);
	  }
  }
  
  
  function hideShowPollTime1stTimeOnAddEditFields(dlgReadPtJq,isAdd){
	  var readPointOperationModeDialogId = getOperationModeDialogId(dlgReadPtJq);
	  var readPointPollTimeLabelId = getReadPtPollTimeLabelId(dlgReadPtJq);
	  var readPointPollTimeDialogId = getReadPtPollTimeDialogId(dlgReadPtJq);
	  var readPointPollTimeRangeDialogId = getReadPtPollTimeRangeLabelId(dlgReadPtJq);
	  if(readPointOperationModeDialogId.val() == ModbusReadPointsConfig.userDefinedMode){
		  readPointPollTimeLabelId.show();
		  readPointPollTimeDialogId.show();
		  readPointPollTimeRangeDialogId.show();  
	  }else{
		  readPointPollTimeLabelId.hide();
		  readPointPollTimeDialogId.hide();
		  readPointPollTimeRangeDialogId.hide();
		  if(isAdd == true){
			  readPointPollTimeDialogId.val(0);  
			  }
	  }
  }
  
  
  function addModbusReadPointDialog(widget){  
	  var addDialogDom;
	  var modbusDeviceReadPtObj = baja.$('honIrmControl:ModbusReadPoint');
	  
	  $( "#addButtonReadPointId" ).click(function(event) {
			 //create dialog
			  event.preventDefault();
			  dialogs.showOkCancel({
			         title: honIrmControlLex.get('honIrmControlLex.add.readpoint.dialog.title.label'),
			         content: function(dlg, dlgAddReadPtJq) {
			        	 dlgAddReadPtJq.html(templateReadPointDialog({
			            	 //lexicon text goes here
			       	      ReadPointName: honIrmControlLex.get('honIrmControlLex.readpoint.name.label'),
			    	      ReadPointType: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointType.label'),
			    	      ReadPointAddressDialog: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointAddress.label'),
			    	      pointAddressRange:honIrmControlLex.get('honIrmControlLex.modbus.readpoint.address.range'),
			    	      ReadPointOperationMode: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointOperationMode.label'),
			    	      ReadPointPollTime: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointPollTime.label'),
			    	      ReadPointPollTimeRange: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointPollTime.range'),
			    	      ScalingFactor: honIrmControlLex.get('honIrmControlLex.readpoint.ScalingFactor.label'),
			    	      ScalingFactorRange: honIrmControlLex.get('honIrmControlLex.modbus.device.readPoint.scalingFactor.range'),
			    	      ReadDataFormat: honIrmControlLex.get('honIrmControlLex.readpoint.DataFormat.label'),
			    	      EventBitMasking: honIrmControlLex.get('honIrmControlLex.readpoint.EventBitMasking.label'),
			    	      EventBitMaskingRange:  honIrmControlLex.get('honIrmControlLex.modbus.device.readPoint.eventBitMasking.range'),
			             }));
			        	
			        	 
			             //populate the data in add dialog 
			        	 //read Point type
			            var readPointTypeAddDialogId = getReadPointTypeOnDialogId(dlgAddReadPtJq);
			     		var optionPtType = '',
			     		readPtTypeOrdinals = modbusDeviceReadPtObj.getReadPointType().$map.$map.valueFacets.$val.get("range").getOrdinals();
			    		for (var i=0;i<readPtTypeOrdinals.length;i++){		
			    				var optionPointTypeVal =  modbusDeviceReadPtObj.getReadPointType().$map.$map.valueFacets.$val.get("range").getTag(readPtTypeOrdinals[i]);
			    				optionPtType += '<option value="'+ readPtTypeOrdinals[i] + '">' + optionPointTypeVal + '</option>';
			    		}
			    		readPointTypeAddDialogId.append(optionPtType);
			    		readPointTypeAddDialogId.val(readPtTypeOrdinals[0].toString());
			             // OperationMode
			            var readPointOperationModeAddDialogId =  getOperationModeDialogId(dlgAddReadPtJq);
			     		var optionOperationMode = '';
			    		for (var j=0;j<widget.readPtOperationModeOrdinals.length;j++){		
			    			    var optionPointOperationModeVal =  widget.readPtOperationModeRange.getTag(widget.readPtOperationModeOrdinals[j]);
			    				optionOperationMode += '<option value="'+ widget.readPtOperationModeOrdinals[j] + '">' + optionPointOperationModeVal + '</option>';
			    		}
			    		readPointOperationModeAddDialogId.append(optionOperationMode);
			    		readPointOperationModeAddDialogId.val(widget.readPtOperationModeOrdinals[1].toString());
			    		//data format
			            var readPointDataFormatAddDialogId = getDataFormatDialogId(dlgAddReadPtJq);
			     		var optionDataFormat = '',
			     		readPtDataFormatOrdinals = modbusDeviceReadPtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getOrdinals();
			    		for (var k=0;k<readPtDataFormatOrdinals.length;k++){		
			    				var optionPointDataFormatVal =  modbusDeviceReadPtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getTag(readPtDataFormatOrdinals[k]);
			    				optionDataFormat += '<option value="'+ readPtDataFormatOrdinals[k] + '">' + optionPointDataFormatVal + '</option>';
			    		}
			    		readPointDataFormatAddDialogId.append(optionDataFormat);
			    		readPointDataFormatAddDialogId.val(readPtDataFormatOrdinals[0].toString());
			    		addDialogDom = dlgAddReadPtJq;
			    		
			    		handleModbusReadPointOperationTypeEventDialog(dlgAddReadPtJq,true);
			    		hideShowPollTime1stTimeOnAddEditFields(dlgAddReadPtJq,true);
			    		
			             },
			         private: false //ensures background contents are screened when the dialog is showing
			         
			       })
			       .ok(function () {
			    	 var isErrorDialogShown = addRowToReadPointTableOnAdd(addDialogDom,modbusDeviceReadPtObj,widget);
			    	 if(isErrorDialogShown == true){
			    		 return false;
			    	 }
			    	 widget.setModified(true);
			       })
			       .cancel(function () {
			    	   return true;
				    });			  
			});  
     }
  
  function createModbusOverviewContent(modbusDevice, widget){
	  var modbusDevNameDom = getModBusDeviceName(),
	  modbusDevAddressDom= getModBusDeviceAddress(),
	  modbusDevByteOrderDom = getModBusDeviceByteOrder(),
	  modbusDevPointCountDom = getModBusDevicePointCount();
   
	  modbusDevNameDom.text(modbusDevice.getDisplayName()); 
	  
	  var modbusServerSideclassName = "honIrmControl:ModbusServerSideCallHandler";
	  var getModbusPropFunction  = "getModbusDeviceProperties";

	  return modbusDevice.serverSideCall({
		  typeSpec:   modbusServerSideclassName,
		  methodName: getModbusPropFunction
	   })
	  	.then(function(modbusDevicePropResult) {	  				
	  			loadModBusModBusDeviceAddressInView(modbusDevAddressDom,modbusDevicePropResult);	  				
	  			loadModBusByteOrderInView(modbusDevByteOrderDom,modbusDevicePropResult);   
	  			loadModBusPointCountInView(modbusDevPointCountDom,modbusDevicePropResult);
	  		    widget.readPtOperationModeOrdinals = modbusDevicePropResult.get(readPtOperationMode).$range.getOrdinals();
	  		    widget.readPtOperationModeRange = modbusDevicePropResult.get(readPtOperationMode).$range;
	  			})
     .catch(function(err) {
       return Promise.reject(err);
     });

  }
  
  function populateModbusReadPointsTable(widget,modbusReadInputsResult) {	
	  var modbusReadPointsArr = modbusReadInputsResult.getSlots().properties().is("baja:Component").toValueArray();
	  var dom = widget.jq();
	 
	  var inputTableBody = getReadPointTableFromDocument(); //modbus-comp-table-body div   <span class="tooltiptext">Tooltip text</span>
	  
	  var modbusDeviceReadPtObj = baja.$('honIrmControl:ModbusReadPoint');
	  var readPtTypeOrdinals = modbusDeviceReadPtObj.getReadPointType().$map.$map.valueFacets.$val.get("range").getOrdinals();
	  
	  var readPtDataFormatOrdinals = modbusDeviceReadPtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getOrdinals();
	  
	  for (var i = 0; i <modbusReadPointsArr.length; i++) {
	   var readPointTableRowId = "readPointTableRow"+i,
		       readPtName = baja.SlotPath.unescape(modbusReadPointsArr[i].getReadPointName()),
		       readPtTypeOrdinal = modbusReadPointsArr[i].getReadPointType().$ordinal,
		       readPtAddress = modbusReadPointsArr[i].getReadPointAddress(),
		       readPtOperationMode = modbusReadPointsArr[i].getOperationMode().$ordinal,
		       readPtPollTime =      modbusReadPointsArr[i].getPollTime(),
		       readPtScalingFactor = modbusReadPointsArr[i].getScalingFactor(),
		       readPtDataFormat = modbusReadPointsArr[i].getDataFormat().$ordinal,
		       readPointTableRowIdJq = "#"+readPointTableRowId,
		       oldFb = modbusReadPointsArr[i].getOldFb(),		       
		   	   oldPointName = modbusReadPointsArr[i].getOldPointName(),
		   	   existingSlotPath = modbusReadPointsArr[i].getExistingSlotPath(),
		       readPtEventBitMasking = modbusUtil.convertAndshowInHex(modbusReadPointsArr[i].getEventBitMasking()), //long value
		       checkBoxReadPtId = "checkBoxReadPoint"+i,
		       optionPointTypeVal,
		       optionPointOperationModeVal,
		       optionPointDataFormatVal;
	   

		            
		   for (var m=0;m<readPtTypeOrdinals.length;m++){				   
			   if(readPtTypeOrdinal == readPtTypeOrdinals[m]){
				   optionPointTypeVal =  modbusDeviceReadPtObj.getReadPointType().$map.$map.valueFacets.$val.get("range").getTag(readPtTypeOrdinals[m]);
				   break;
			   }		   
		   }
		   
		   for (var j=0;j< widget.readPtOperationModeOrdinals.length;j++){
			   if(readPtOperationMode ==  widget.readPtOperationModeOrdinals[j]){
				   optionPointOperationModeVal =  widget.readPtOperationModeRange.getTag(widget.readPtOperationModeOrdinals[j]);
				   break;
			   }
		   }
		   
		   for (var k=0;k<readPtDataFormatOrdinals.length;k++){
			   if(readPtDataFormat == readPtDataFormatOrdinals[k]){
				  optionPointDataFormatVal =  modbusDeviceReadPtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getTag(readPtDataFormatOrdinals[k]);
				  break;
			   }
		   }
		   
		     
		    inputTableBody.innerHTML += "<div class=\"md-table-row\" id="+ readPointTableRowId +" onmouseover=\"this.style.background='#E8E8E8';\" onmouseout=\"this.style.background='#ffffff';\">  "   +
	        "<div class=\"modbus-comp-table-cell\" title=\""+readPtName+"\" data="+"\""+ readPtName +"\""+" >"+ readPtName+" </div>  "  +
	        "<div class=\"modbus-comp-table-cell\" title=\""+ optionPointTypeVal +"\" data="+"\""+readPtTypeOrdinal +"\""+" >"+ optionPointTypeVal +" </div> " +
	        "<div class=\"modbus-comp-table-cell\" data="+"\""+ readPtAddress +"\""+" >"+readPtAddress +" </div> "+
	        "<div class=\"modbus-comp-table-cell\" data="+"\""+ readPtOperationMode   +"\""+" >"+ optionPointOperationModeVal +" </div> "+
	        "<div class=\"modbus-comp-table-cell\" data="+"\""+ readPtPollTime+"\""+" >"+ modbusReadPointsArr[i].getPollTimeDisplay() +" </div> "+
	        "<div class=\"modbus-comp-table-cell\" data="+"\""+ readPtScalingFactor+"\""+" >"+ modbusReadPointsArr[i].getScalingFactorDisplay() +" </div> "+
	        "<div class=\"modbus-comp-table-cell\" data="+"\""+ readPtDataFormat  +"\""+" >"+optionPointDataFormatVal +" </div> "+  
	        "<div class=\"modbus-comp-table-cell\" data="+"\""+ readPtEventBitMasking +"\""+" >"+readPtEventBitMasking +" </div> "+  //convert to hex and show as from station it comes as long
	        "<div class=\"modbus-comp-table-cell\">" + "<input id="+ checkBoxReadPtId +" type=\"checkbox\"  />" + " </div> "+
	        "</div>";
		    
  	
	    
		    var param = {
			    	mainView:widget,
			    	rowIdJq:readPointTableRowIdJq,
			    	readPtName: readPtName,
			    	readPtTypeOrdinal: readPtTypeOrdinal,
			    	readOptionPointTypeVal: optionPointTypeVal,
			    	readPtAddress: readPtAddress,
			    	readPtOperationMode:readPtOperationMode,
			    	readPtOperationModeVal:optionPointOperationModeVal,
			    	readPtPollTime:readPtPollTime,
			    	readPtScalingFactor: readPtScalingFactor,
			    	readPtDataFormat: readPtDataFormat,
			    	optionPointDataFormatVal: optionPointDataFormatVal,
			    	oldFb:oldFb,
			    	oldPointName:oldPointName,
			    	existingSlotPath: existingSlotPath,
			    	readPtEventBitMasking:readPtEventBitMasking
			     };
		    
		    
			dom.on("change", "#"+checkBoxReadPtId,widget, function(event){
				modbusReadPointsConfig.handleSelectAllCheckBoxStatusFromReadPointsTable( "#"+event.currentTarget.id,event.data);
				});
		    
		    dom.on('click', readPointTableRowIdJq,
		    		param,
		    		 function (event) {      	
			        	initializeEditDialogForReadPoint(event);
				     });
		    
		    widget.readPointDataList[checkBoxReadPtId] = param;
		    
		    
		    
		    dom.on("mouseover", "#"+checkBoxReadPtId, function() {
		    	dom.off('click', widget.readPointDataList[this.id].rowIdJq);
		    });		    
		    
		    dom.on("mouseout", "#"+checkBoxReadPtId, function() {
		    	dom.on('click', widget.readPointDataList[this.id].rowIdJq,
		    			widget.readPointDataList[this.id],
			     function (event) {      	
			        	initializeEditDialogForReadPoint(event);
				     });
		    });	
		    
		    }
	  
	    modbusReadPointsConfig.sortReadTableOnSelectedFilter(widget,ModbusReadPointsConfig.activeFilterReadPts);
	  
	  
	   setModBusDeviceReadWritePointCount(true,Object.keys(widget.readPointDataList).length);
	}
  
  
  function populateModbusWritePointsTable(widget,modbusWriteInputsResult) {
	  var modbusWritePointsArr = modbusWriteInputsResult.getSlots().properties().is("baja:Component").toValueArray();
	  var dom = widget.jq();
	 
	  var ouputTableBody = getWritePointTableFromDocument(); //modbus-comp-table-body div   <span class="tooltiptext">Tooltip text</span>
	  
	  var modbusDeviceWritePtObj = baja.$('honIrmControl:ModbusWritePoint');
	  var writePtTypeOrdinals = modbusDeviceWritePtObj.getWritePointType().$map.$map.valueFacets.$val.get("range").getOrdinals();
	  var writePtDataFormatOrdinals = modbusDeviceWritePtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getOrdinals();
	  
	  for (var i = 0; i <modbusWritePointsArr.length; i++) {
		  
		   var writePointTableRowId = "writePointTableRow"+i,
		       writePtName = baja.SlotPath.unescape(modbusWritePointsArr[i].getName()),
		       writePtTypeOrdinal = modbusWritePointsArr[i].getWritePointType().$ordinal,
		       writePtAddress = modbusWritePointsArr[i].getWritePointAddress(),
		       writePtSignificantChange = modbusWritePointsArr[i].getSignificantChange(),
		       writePtDataFormatOrdinal = modbusWritePointsArr[i].getDataFormat().$ordinal,
		       writePointTableRowIdJq = "#"+writePointTableRowId,
		       oldFb = modbusWritePointsArr[i].getOldFb(),		       
		   	   oldPointName = modbusWritePointsArr[i].getOldPointName(),
		   	   existingSlotPath = modbusWritePointsArr[i].getExistingSlotPath(),
		       checkBoxWritePtId = "checkBoxWritePoint"+i,
		       optionPointTypeVal,
		       optionPointDataFormatVal;
		   
		   
		   for (var m=0;m<writePtTypeOrdinals.length;m++){	
			   if(writePtTypeOrdinal == writePtTypeOrdinals[m]){
			   optionPointTypeVal =  modbusDeviceWritePtObj.getWritePointType().$map.$map.valueFacets.$val.get("range").getTag(writePtTypeOrdinals[m]);
			   break;
			   }
		   }
		   
		   for (var k=0;k<writePtDataFormatOrdinals.length;k++){
			   if(writePtDataFormatOrdinal == writePtDataFormatOrdinals[k]){
			   optionPointDataFormatVal =  modbusDeviceWritePtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getTag(writePtDataFormatOrdinals[k]);
			   break;
			   }
		   }
		     
		   ouputTableBody.innerHTML += "<div class=\"md-table-row\" id="+ writePointTableRowId +" onmouseover=\"this.style.background='#E8E8E8';\" onmouseout=\"this.style.background='#ffffff';\">  "   +
	        "<div class=\"modbus-comp-table-cell\" title=\""+writePtName+"\" data="+"\""+ writePtName +"\""+" >"+ writePtName+" </div>  "  +
	        "<div class=\"modbus-comp-table-cell\" title=\""+ optionPointTypeVal +"\" data="+"\""+writePtTypeOrdinal +"\""+" >"+ optionPointTypeVal +" </div> " +
	        "<div class=\"modbus-comp-table-cell\" data="+"\""+ writePtAddress +"\""+" >"+writePtAddress +" </div> "+
	        "<div class=\"modbus-comp-table-cell\" data="+"\""+ writePtSignificantChange   +"\""+" >"+ modbusWritePointsArr[i].getSignificantChangeDisplay() +" </div> "+
	        "<div class=\"modbus-comp-table-cell\" data="+"\""+ writePtDataFormatOrdinal  +"\""+" >"+optionPointDataFormatVal +" </div> "+  
	        "<div class=\"modbus-comp-table-cell\">" + "<input id="+ checkBoxWritePtId +" type=\"checkbox\"  />" + " </div> "+
	        "</div>";
		    
		    
			dom.on("change", "#"+checkBoxWritePtId, widget,function(event){
			    modbusWritePointsConfig.handleSelectAllCheckBoxStatusFromWritePointsTable( "#"+event.currentTarget.id,event.data);
				});  	
	    
		    var param = {
			    	mainView:widget,
			    	rowIdJq:writePointTableRowIdJq,
			    	writePtName: writePtName,
			    	writePtTypeOrdinal: writePtTypeOrdinal,
			    	writePtTypeValue:optionPointTypeVal,
			    	writePtAddress: writePtAddress,
			    	writePtSignificantChange: writePtSignificantChange,
			    	writePtDataFormatOrdinal: writePtDataFormatOrdinal,
			    	writePtDataFormatValue:optionPointDataFormatVal,
			    	oldFb:oldFb,
			    	oldPointName:oldPointName,
			    	existingSlotPath: existingSlotPath
			     };
		    
		    widget.writePointDataList[checkBoxWritePtId] = param;
		    
		    dom.on('click', writePointTableRowIdJq,
		    		widget.writePointDataList[checkBoxWritePtId],		    		
		    		 function (event) {      	
			        	initializeEditDialogForWritePoint(event);
				     });
		    
		    
		    dom.on("mouseover", "#"+checkBoxWritePtId, function() {
		    	dom.off('click', widget.writePointDataList[this.id].rowIdJq);
		    });		    
		    
		    dom.on("mouseout", "#"+checkBoxWritePtId, function() {
		    	dom.on('click', widget.writePointDataList[this.id].rowIdJq,
		    			widget.writePointDataList[this.id],
			     function (event) {      	
		    		initializeEditDialogForWritePoint(event);
				     });
		    });	
    
		    }
	  
	  modbusWritePointsConfig.sortWriteTableOnSelectedFilter(widget,ModbusWritePointsConfig.activeFilterWritePts);
	  
	  setModBusDeviceReadWritePointCount(false,Object.keys(widget.writePointDataList).length);
	  
  }
  
  function initializeEditDialogForWritePoint(event){
	  var mainView = event.data.mainView;
	  var editDialogDom;
	  var rowWritePtId =  event.data.rowIdJq;
	  var modbusDeviceWritePtObj = baja.$('honIrmControl:ModbusWritePoint');
	  event.preventDefault();
	  dialogs.showOkCancel({
	         title: honIrmControlLex.get('honIrmControlLex.Edit.writepoint.dialog.title.label'),
	         content: function(dlg, dlgEditWritePtJq) {
	        	 dlgEditWritePtJq.html(modbusWritePointDialog({
	            	 //lexicon text goes here
	        		 WritePointName: honIrmControlLex.get('honIrmControlLex.writepoint.WritePointName.label'),
	        		 WritePointType: honIrmControlLex.get('honIrmControlLex.writepoint.WritePointType.label'),
	        		 WritePointAddressDialog: honIrmControlLex.get('honIrmControlLex.writepoint.WritePointAddress.label'),
	        		 pointAddressRange:honIrmControlLex.get('honIrmControlLex.modbus.writepoint.address.range'),
	        		 SignificantChange: honIrmControlLex.get('honIrmControlLex.writepoint.SignificantChange.label'),
	    	         WritePointDataFormat: honIrmControlLex.get('honIrmControlLex.writepoint.WriteDataFormat.label'),
	             }));
	             //populate the data in Edit dialog 
	        	 //read Point type 
	            var writePointTypeEditDialogId = getWritePointTypeOnDialogId(dlgEditWritePtJq);
	     		var optionPtType = '',
	     		writePtTypeOrdinals = modbusDeviceWritePtObj.getWritePointType().$map.$map.valueFacets.$val.get("range").getOrdinals();
	    		for (var i=0;i<writePtTypeOrdinals.length;i++){		
	    				var optionPointTypeVal =  modbusDeviceWritePtObj.getWritePointType().$map.$map.valueFacets.$val.get("range").getTag(writePtTypeOrdinals[i]);
	    				optionPtType += '<option value="'+ writePtTypeOrdinals[i] + '">' + optionPointTypeVal + '</option>';
	    		}
	    		writePointTypeEditDialogId.append(optionPtType);
	    		writePointTypeEditDialogId.val(event.data.writePtTypeOrdinal);
	    		//data format
	            var writePointDataFormatEditDialogId = getWritePointDataFormatDialogId(dlgEditWritePtJq);
	     		var optionDataFormat = '',
	     		writePtDataFormatOrdinals = modbusDeviceWritePtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getOrdinals();
	    		for (var k=0;k<writePtDataFormatOrdinals.length;k++){		
	    				var optionPointDataFormatVal =  modbusDeviceWritePtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getTag(writePtDataFormatOrdinals[k]);
	    				optionDataFormat += '<option value="'+ writePtDataFormatOrdinals[k] + '">' + optionPointDataFormatVal + '</option>';
	    		}
	    		writePointDataFormatEditDialogId.append(optionDataFormat);
	    		writePointDataFormatEditDialogId.val(event.data.writePtDataFormatOrdinal);
	    			
	    		
	    	   var significantChangerEditDialogId = getSignificantChangeDialogId(dlgEditWritePtJq);
	    	   significantChangerEditDialogId.val(event.data.writePtSignificantChange);
	    	   var writePointAddressEditDialogId = getWritePointAddressDialogId(dlgEditWritePtJq);
	    	   writePointAddressEditDialogId.val(event.data.writePtAddress);
	    	   var writePointNameEditDialogId = getWritePointNameDialogId(dlgEditWritePtJq);
	    	   writePointNameEditDialogId.val(event.data.writePtName);
	    		
	    	   editDialogDom = dlgEditWritePtJq;
	             },
	         private: false //ensures background contents are screened when the dialog is showing
	       })
	       .ok(function () {
	    	 var isShownErrorDialog = EditRowToWritePointTable(editDialogDom,modbusDeviceWritePtObj,rowWritePtId,mainView);
	    	 if(isShownErrorDialog == true){
	    		 return false;
	    	 }
	    	 mainView.setModified(true);
	       })
	       .cancel(function () {
	    	   return true;
		    });	
	  
  }
  
  
  function initializeEditDialogForReadPoint(event){
	  var mainView = event.data.mainView;
	  var editDialogDom;
	  var rowReadPtId =  event.data.rowIdJq;
	  var modbusDeviceReadPtObj = baja.$('honIrmControl:ModbusReadPoint');
	  event.preventDefault();
	  dialogs.showOkCancel({
	         title: honIrmControlLex.get('honIrmControlLex.Edit.readpoint.dialog.title.label'),
	         content: function(dlg, dlgEditReadPtJq) {
	        	 dlgEditReadPtJq.html(templateReadPointDialog({
	            	 //lexicon text goes here
	       	      ReadPointName: honIrmControlLex.get('honIrmControlLex.readpoint.name.label'),
	    	      ReadPointType: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointType.label'),
	    	      ReadPointAddressDialog: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointAddress.label'),
	    	      pointAddressRange:honIrmControlLex.get('honIrmControlLex.modbus.readpoint.address.range'),
	    	      ReadPointOperationMode: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointOperationMode.label'),
	    	      ReadPointPollTime: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointPollTime.label'),
	    	      ReadPointPollTimeRange: honIrmControlLex.get('honIrmControlLex.readpoint.ReadPointPollTime.range'),
	    	      ScalingFactor: honIrmControlLex.get('honIrmControlLex.readpoint.ScalingFactor.label'),
	    	      ScalingFactorRange: honIrmControlLex.get('honIrmControlLex.modbus.device.readPoint.scalingFactor.range'),
	    	      ReadDataFormat: honIrmControlLex.get('honIrmControlLex.readpoint.DataFormat.label'),
	    	      EventBitMasking: honIrmControlLex.get('honIrmControlLex.readpoint.EventBitMasking.label'),
	    	      EventBitMaskingformat:  honIrmControlLex.get('honIrmControlLex.readpoint.EventBitMasking.label.format'),
	    	      EventBitMaskingRange:  honIrmControlLex.get('honIrmControlLex.modbus.device.readPoint.eventBitMasking.range'),
	             }));
	             //populate the data in Edit dialog 
	        	 //read Point type 
	            var readPointTypeEditDialogId = getReadPointTypeOnDialogId(dlgEditReadPtJq);
	     		var optionPtType = '',
	     		readPtTypeOrdinals = modbusDeviceReadPtObj.getReadPointType().$map.$map.valueFacets.$val.get("range").getOrdinals();
	    		for (var i=0;i<readPtTypeOrdinals.length;i++){		
	    				var optionPointTypeVal =  modbusDeviceReadPtObj.getReadPointType().$map.$map.valueFacets.$val.get("range").getTag(readPtTypeOrdinals[i]);
	    				optionPtType += '<option value="'+ readPtTypeOrdinals[i] + '">' + optionPointTypeVal + '</option>';
	    		}
	    		readPointTypeEditDialogId.append(optionPtType);
	    		readPointTypeEditDialogId.val(event.data.readPtTypeOrdinal);
	             // OperationMode
	            var readPointOperationModeEditDialogId =  getOperationModeDialogId(dlgEditReadPtJq);
	     		var optionOperationMode = '';
	    		for (var j=0;j<mainView.readPtOperationModeOrdinals.length;j++){		
	    			    var optionPointOperationModeVal = mainView.readPtOperationModeRange.getTag(mainView.readPtOperationModeOrdinals[j]);
	    				optionOperationMode += '<option value="'+ mainView.readPtOperationModeOrdinals[j] + '">' + optionPointOperationModeVal + '</option>';
	    		}
	    		readPointOperationModeEditDialogId.append(optionOperationMode);
	    		readPointOperationModeEditDialogId.val(event.data.readPtOperationMode);
	    		//data format
	            var readPointDataFormatEditDialogId = getDataFormatDialogId(dlgEditReadPtJq);
	     		var optionDataFormat = '',
	     		readPtDataFormatOrdinals = modbusDeviceReadPtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getOrdinals();
	    		for (var k=0;k<readPtDataFormatOrdinals.length;k++){		
	    				var optionPointDataFormatVal =  modbusDeviceReadPtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getTag(readPtDataFormatOrdinals[k]);
	    				optionDataFormat += '<option value="'+ readPtDataFormatOrdinals[k] + '">' + optionPointDataFormatVal + '</option>';
	    		}
	    		readPointDataFormatEditDialogId.append(optionDataFormat);
	    		readPointDataFormatEditDialogId.val(event.data.readPtDataFormat);
	    			
	    		
	    	   var scalingFactorEditDialogId = getScalingFactorDialogId(dlgEditReadPtJq);
	    	   scalingFactorEditDialogId.val(event.data.readPtScalingFactor);
	    	   var readPointAddressEditDialogId = getReadPointAddressDialogId(dlgEditReadPtJq);
	    	   readPointAddressEditDialogId.val(event.data.readPtAddress);
	    	   var readPointNameEditDialogId = getReadPointNameDialogId(dlgEditReadPtJq);
	    	   readPointNameEditDialogId.val(event.data.readPtName);
	    	   var readPointEventBitMaskingDialogId = getReadPointEventBitMaskingDialogId(dlgEditReadPtJq);
	    	   readPointEventBitMaskingDialogId.val(event.data.readPtEventBitMasking);
	    	   
	    	   var readPtPollTimeEditDialogId = getReadPtPollTimeDialogId(dlgEditReadPtJq);
	    	   readPtPollTimeEditDialogId.val(event.data.readPtPollTime);
	    	   
	    		
	    	   editDialogDom = dlgEditReadPtJq;
	    	   
	    	   handleModbusReadPointOperationTypeEventDialog(dlgEditReadPtJq,false);
	    	   hideShowPollTime1stTimeOnAddEditFields(dlgEditReadPtJq,false);
	             },
	         private: false //ensures background contents are screened when the dialog is showing
	       })
	       .ok(function () {
	    	 var isErrorDialogShown = EditRowToReadPointTable(editDialogDom,modbusDeviceReadPtObj,rowReadPtId,mainView);
	    	 if(isErrorDialogShown == true){
	    		 return false;
	    	 }
	    	 mainView.setModified(true);
	       })
	       .cancel(function () {
	    	   return true;
		    });	
	  
  }
  
  
  function  EditRowToWritePointTable(dlgEditWritePtJq,modbusDeviceWritePtObj,rowWritePtId,widget){
	  
	  var dom = widget.jq();
		//scaling factor
	   var significantChangeEditDialogId = getSignificantChangeDialogId(dlgEditWritePtJq);
	   var writePointAddressEditDialogId = getWritePointAddressDialogId(dlgEditWritePtJq);
	   var writePointNameEditDialogId = getWritePointNameDialogId(dlgEditWritePtJq);
	   
		  
	   var significantChangeVal = significantChangeEditDialogId.val();
	   var writePointAddressVal = writePointAddressEditDialogId.val()
	   var writePointNameVal = writePointNameEditDialogId.val();
	   
	   var isShownErrorDialog = modbusWritePointsConfig.showErrorDiaogOnAddEditWritePoint(significantChangeVal,writePointAddressVal,writePointNameVal);
	   if(isShownErrorDialog == true ){
			  return isShownErrorDialog;
		  }
	  
	  //read point type
	  var writePointTypeEditDialogId = getWritePointTypeOnDialogId(dlgEditWritePtJq);  
	  var writePtTypeOrdinals = modbusDeviceWritePtObj.getWritePointType().$map.$map.valueFacets.$val.get("range").getOrdinals();
	  var writeOptionPointTypeVal;
		for (var i=0;i<writePtTypeOrdinals.length;i++){				
			if(writePtTypeOrdinals[i]  == writePointTypeEditDialogId.val() ){
				writeOptionPointTypeVal =  modbusDeviceWritePtObj.getWritePointType().$map.$map.valueFacets.$val.get("range").getTag(writePtTypeOrdinals[i]);
				break;
			}
		}
    
		//read point data format
	  var writePointDataFormatEditDialogId = getWritePointDataFormatDialogId(dlgEditWritePtJq);
	  var optionPointDataFormatVal;

	 var writePtDataFormatOrdinals = modbusDeviceWritePtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getOrdinals();
		for (var k=0;k<writePtDataFormatOrdinals.length;k++){						
				if(writePtDataFormatOrdinals[k]  == writePointDataFormatEditDialogId.val() ){
					optionPointDataFormatVal =  modbusDeviceWritePtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getTag(writePtDataFormatOrdinals[k]);
					break;
				}
		}
		
	     var count= rowWritePtId.substring(19);//#writePointTableRow0
	     var countNumber = Number(count);

		  var checkBoxWritePtId = "checkBoxWritePoint"+countNumber;
		  
		  var existingParam = widget.writePointDataList[checkBoxWritePtId];
		
		    var param = {
			    	mainView:widget,
			    	rowIdJq:rowWritePtId,
			    	writePtName: writePointNameVal,
			    	writePtTypeOrdinal: writePointTypeEditDialogId.val(), 
			    	writePtTypeValue:writeOptionPointTypeVal,
			    	writePtAddress: writePointAddressVal,
			    	writePtSignificantChange: significantChangeVal,
			    	writePtDataFormatOrdinal: writePointDataFormatEditDialogId.val(),
			    	writePtDataFormatValue:optionPointDataFormatVal,
			    	oldFb: existingParam.oldFb,
			    	oldPointName: existingParam.oldPointName,
			    	existingSlotPath: existingParam.existingSlotPath
			     };
		    
			   var isError = modbusWritePointsConfig.validateWritePtAddressAndType( widget.readPointDataList,param,widget.writePointDataList);
			   if(isError == true){
				   return isError;
			   }
    
		    widget.writePointDataList[checkBoxWritePtId] = param;

		    dom.off('click', widget.writePointDataList[checkBoxWritePtId].rowIdJq);
		  
		    dom.on('click', widget.writePointDataList[checkBoxWritePtId].rowIdJq,
		    			widget.writePointDataList[checkBoxWritePtId],
			     function (event) {      	
		    		initializeEditDialogForWritePoint(event);
		   });


   
	  var writePointcells = $(rowWritePtId).find("div.modbus-comp-table-cell");
	  
	  for (var l = 0; l <writePointcells.length; l++) { // 0 1 2 3
			 if( l==0 ){
				 writePointcells[l].innerText = writePointNameVal;
				 writePointcells[l].setAttribute("data",writePointNameVal);
				 writePointcells[l].setAttribute("title",writePointNameVal);
			 }
			 else if(l==1){
				 writePointcells[l].innerText = writeOptionPointTypeVal;
				 writePointcells[l].setAttribute("data",writePointTypeEditDialogId.val());
				 writePointcells[l].setAttribute("title",writeOptionPointTypeVal);
			 }			 
			 else if(l==2){
				 writePointcells[l].setAttribute("data",writePointAddressVal);
				 
				 if(writePointAddressVal.toString().toUpperCase().includes("0X")){
					 writePointcells[l].innerText = modbusUtil.showAddressInDecAndHexFromHex(writePointAddressVal); 
				 }else{
					 writePointcells[l].innerText = modbusUtil.showAddressInDecAndHex(writePointAddressVal); 
				 }
			 }
			 else if(l==3){			 
				 writePointcells[l].innerText = significantChangeVal;
				 writePointcells[l].setAttribute("data",significantChangeVal); 
			 } 
			 else if(l==4){
				 writePointcells[l].innerText = optionPointDataFormatVal;
				 writePointcells[l].setAttribute("data",writePointDataFormatEditDialogId.val()); 
			 }  
		  } 
	  
	  modbusWritePointsConfig.sortWriteTableOnSelectedFilter(widget,ModbusWritePointsConfig.activeFilterWritePts);
	  
  }
  
  
  function  EditRowToReadPointTable(dlgEditReadPtJq,modbusDeviceReadPtObj,rowReadPtId,widget){
	  
	  var dom = widget.jq();
		//scaling factor
  	  
	  var scalingFactorEditDialogId = getScalingFactorDialogId(dlgEditReadPtJq);
	  var readPointAddressEditDialogId = getReadPointAddressDialogId(dlgEditReadPtJq);
	  var readPointNameEditDialogId = getReadPointNameDialogId(dlgEditReadPtJq);
	  var readPointEventBitMaskingDialogId = getReadPointEventBitMaskingDialogId(dlgEditReadPtJq);
	  var readPtPollTimeEditDialogId = getReadPtPollTimeDialogId(dlgEditReadPtJq);
	  var readPtOperationModeDialogId = getOperationModeDialogId(dlgEditReadPtJq);
	  
	  var scalingFactorEditVal =  scalingFactorEditDialogId.val();
	  var readPointAddressEditVal = readPointAddressEditDialogId.val();
	  var readPointNameEditVal = readPointNameEditDialogId.val();
	  var eventBitMaskingVal = readPointEventBitMaskingDialogId.val();
	  var readPtPollTimeEditVal =  readPtPollTimeEditDialogId.val();
	  var readPtOperationModeVal = readPtOperationModeDialogId.val();
	 
	  
	  var isErrorDialogShown = modbusReadPointsConfig.showErrorDiaogOnAddEditReadPoint(scalingFactorEditVal,readPointAddressEditVal,readPointNameEditVal,eventBitMaskingVal,readPtPollTimeEditVal,readPtOperationModeVal);
	  
	  if(true == isErrorDialogShown){
		  return isErrorDialogShown;
	  }
	  
	  //read point type
	  var readPointTypeEditDialogId = getReadPointTypeOnDialogId(dlgEditReadPtJq);  
	  var readPtTypeOrdinals = modbusDeviceReadPtObj.getReadPointType().$map.$map.valueFacets.$val.get("range").getOrdinals();
	  var readOptionPointTypeVal;
		for (var i=0;i<readPtTypeOrdinals.length;i++){				
			if(readPtTypeOrdinals[i]  == readPointTypeEditDialogId.val() ){
				readOptionPointTypeVal =  modbusDeviceReadPtObj.getReadPointType().$map.$map.valueFacets.$val.get("range").getTag(readPtTypeOrdinals[i]);
				break;
			}
		}
	  
		//read point OperationMode
	  
	  var readPointOperationModeEditDialogId =  getOperationModeDialogId(dlgEditReadPtJq);
		var readPtOperationModeVal;
		for (var j=0;j<widget.readPtOperationModeOrdinals.length;j++){
			if(widget.readPtOperationModeOrdinals[j]  == readPointOperationModeEditDialogId.val() ){
				readPtOperationModeVal = widget.readPtOperationModeRange.getTag(widget.readPtOperationModeOrdinals[j]);
				break;
			}
		}
	    
		//read point data format
	  var readPointDataFormatEditDialogId = getDataFormatDialogId(dlgEditReadPtJq);
	  var optionPointDataFormatVal;

	 var readPtDataFormatOrdinals = modbusDeviceReadPtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getOrdinals();
		for (var k=0;k<readPtDataFormatOrdinals.length;k++){						
				if(readPtDataFormatOrdinals[k]  == readPointDataFormatEditDialogId.val() ){
					optionPointDataFormatVal =  modbusDeviceReadPtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getTag(readPtDataFormatOrdinals[k]);
					break;
				}
		}

	     var count= rowReadPtId.substring(ModbusUtil.eighteenNumber); //#readPointTableRow0
	     var countNumber = Number(count);

		 var checkBoxReadPtId = "checkBoxReadPoint"+countNumber;
		  
		 var existingParam = widget.readPointDataList[checkBoxReadPtId];
		
	    var param = {
		    	mainView:widget,
		    	rowIdJq:rowReadPtId,
		    	readPtName: readPointNameEditVal,
		    	readPtTypeOrdinal: readPointTypeEditDialogId.val(), 
		    	readOptionPointTypeVal: readOptionPointTypeVal,
		    	readPtAddress: readPointAddressEditVal,
		    	readPtOperationMode:readPointOperationModeEditDialogId.val(),
		    	readPtOperationModeVal:readPtOperationModeVal,
		    	readPtPollTime:readPtPollTimeEditVal,
		    	readPtScalingFactor: scalingFactorEditVal,
		    	optionPointDataFormatVal:optionPointDataFormatVal,
		    	readPtDataFormat: readPointDataFormatEditDialogId.val(),
		    	oldFb: existingParam.oldFb,
		    	oldPointName: existingParam.oldPointName,
		    	existingSlotPath: existingParam.existingSlotPath,
		    	readPtEventBitMasking:eventBitMaskingVal
		     };
	    
	    //if point address and type is same then no need to add in read table
		   var isError = modbusReadPointsConfig.validateReadPtAddressAndType( widget.readPointDataList,param,widget.writePointDataList);
		   if(isError == true){
			   return isError;
		   }
	    
	    widget.readPointDataList[checkBoxReadPtId] = param;
	    
	    
	    dom.off('click',  widget.readPointDataList[checkBoxReadPtId].rowIdJq);
		  
	    dom.on('click',  widget.readPointDataList[checkBoxReadPtId].rowIdJq,
	    		 widget.readPointDataList[checkBoxReadPtId],
		     function (event) {      	
	    	initializeEditDialogForReadPoint(event);
	   });
		

	  var readPointcells = $(rowReadPtId).find("div.modbus-comp-table-cell");
	  
	  for (var l = 0; l <readPointcells.length; l++) { // 0 1 2 3
			 if( l==0 ){
				 readPointcells[l].innerText = readPointNameEditVal;
				 readPointcells[l].setAttribute("data",readPointNameEditVal);
				 readPointcells[l].setAttribute("title",readPointNameEditVal);
			 }
			 else if(l==1){
				 readPointcells[l].innerText = readOptionPointTypeVal;
				 readPointcells[l].setAttribute("data",readPointTypeEditDialogId.val());
				 readPointcells[l].setAttribute("title",readOptionPointTypeVal);
			 }			 
			 else if(l==2){
				 readPointcells[l].setAttribute("data",readPointAddressEditVal);
				 
				 if(readPointAddressEditVal.toString().toUpperCase().includes("0X")){
					 readPointcells[l].innerText = modbusUtil.showAddressInDecAndHexFromHex(readPointAddressEditVal);
				 }else{
					 readPointcells[l].innerText = modbusUtil.showAddressInDecAndHex(readPointAddressEditVal);
				 }
				 
			 }				 
			 else if(l==3){
				 readPointcells[l].innerText = readPtOperationModeVal;
				 readPointcells[l].setAttribute("data",readPointOperationModeEditDialogId.val()); 
			 }
			 else if(l==4){
				 readPointcells[l].innerText = readPtPollTimeEditVal;
				 readPointcells[l].setAttribute("data",readPtPollTimeEditVal); 
			 }
			 else if(l==5){			 
				 readPointcells[l].innerText = scalingFactorEditVal;
				 readPointcells[l].setAttribute("data",scalingFactorEditVal); 
			 } 
			 else if(l==6){
				 readPointcells[l].innerText = optionPointDataFormatVal;
				 readPointcells[l].setAttribute("data",readPointDataFormatEditDialogId.val()); 
			 } else if(l==7){
				 readPointcells[l].innerText = modbusUtil.showInHex(eventBitMaskingVal);
				 readPointcells[l].setAttribute("data",eventBitMaskingVal); 
			 }  
		  }  
	  
	  modbusReadPointsConfig.sortReadTableOnSelectedFilter(widget,modbusReadPointsConfig.activeFilterReadPts);
  }
  
  function  addRowToWritePointTableOnAdd(dlgAddWritePtJq,modbusDeviceWritePtObj,widget,dlg){
	  
		//scaling factor
  	  
	  var significantChangeAddDialogId = getSignificantChangeDialogId(dlgAddWritePtJq);
	  var writePointAddressAddDialogId = getWritePointAddressDialogId(dlgAddWritePtJq);
	  var writePointNameAddDialogId = getWritePointNameDialogId(dlgAddWritePtJq);
	  
	  var significantChangeVal = significantChangeAddDialogId.val();
	  var writePointAddressVal = writePointAddressAddDialogId.val()
	  var writePointNameVal = writePointNameAddDialogId.val();
	   
	  
	  var isShownErrorDialog = modbusWritePointsConfig.showErrorDiaogOnAddEditWritePoint(significantChangeVal,writePointAddressVal,writePointNameVal);
	  if(isShownErrorDialog == true ){
		  return isShownErrorDialog;
	  }
	  
	  //read point type
	  var dom = widget.jq();
	  var writePointTypeAddDialogId = getWritePointTypeOnDialogId(dlgAddWritePtJq);  
	  var writePtTypeOrdinals = modbusDeviceWritePtObj.getWritePointType().$map.$map.valueFacets.$val.get("range").getOrdinals();
	  var writeOptionPointTypeVal;
		for (var i=0;i<writePtTypeOrdinals.length;i++){				
			if(writePtTypeOrdinals[i]  == writePointTypeAddDialogId.val() ){
				writeOptionPointTypeVal =  modbusDeviceWritePtObj.getWritePointType().$map.$map.valueFacets.$val.get("range").getTag(writePtTypeOrdinals[i]);
				break;
			}
		}
	    
		//read point data format
	  var writePointDataFormatAddDialogId = getWritePointDataFormatDialogId(dlgAddWritePtJq);
	  var optionPointDataFormatVal;

	 var writePtDataFormatOrdinals = modbusDeviceWritePtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getOrdinals();
		for (var k=0;k<writePtDataFormatOrdinals.length;k++){						
				if(writePtDataFormatOrdinals[k]  == writePointDataFormatAddDialogId.val() ){
					optionPointDataFormatVal =  modbusDeviceWritePtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getTag(writePtDataFormatOrdinals[k]);
					break;
				}
		}
	  
	  var ouputTableBody = getWritePointTableFromDocument();
	  
		var keyListChkBox=  Object.keys(widget.writePointDataList);
		var count = 0,
		writePointTableRowId,
		checkBoxWritePtId;		
		if(keyListChkBox.length > 0){
			//get the last item from keyList
		   var keyChkBoxIdLast = keyListChkBox[keyListChkBox.length-1];
		   count= keyChkBoxIdLast.substring(ModbusUtil.eighteenNumber);
		   count = Number(count)+1;
		 }      
      
      writePointTableRowId = "writePointTableRow"+count;
	  checkBoxWritePtId = "checkBoxWritePoint"+count;
	  
	   var writePtTypeOrdinal = writePointTypeAddDialogId.val(),
       writePtDataFormatOrdinal = writePointDataFormatAddDialogId.val(),
       writePointTableRowIdJq = "#"+writePointTableRowId;
	   
	    var param = {
		    	mainView:widget,
		    	rowIdJq:writePointTableRowIdJq,
		    	writePtName: writePointNameVal,
		    	writePtTypeOrdinal: writePtTypeOrdinal,
		    	writePtTypeValue:writeOptionPointTypeVal,
		    	writePtAddress: writePointAddressVal,
		    	writePtSignificantChange: significantChangeVal,
		    	writePtDataFormatOrdinal: writePtDataFormatOrdinal,
		    	writePtDataFormatValue:optionPointDataFormatVal,
		    	oldFb:false,
		    	oldPointName: "",
		    	existingSlotPath: ""
		     };
	   
	   var isError = modbusWritePointsConfig.validateWritePtAddressAndType( widget.readPointDataList,param,widget.writePointDataList);
	   if(isError == true){
		   return isError;
	   }
	   
	   
	  
	   ouputTableBody.innerHTML += "<div class=\"md-table-row\" id="+ writePointTableRowId +" onmouseover=\"this.style.background='#E8E8E8';\" onmouseout=\"this.style.background='#ffffff';\">  "   +
         "<div class=\"modbus-comp-table-cell\" title=\""+writePointNameVal+"\" data="+"\""+ writePointNameVal+"\""+" >"+  writePointNameVal+" </div>  "  +
        "<div class=\"modbus-comp-table-cell\" title=\""+writeOptionPointTypeVal+"\" data="+"\""+ writePointTypeAddDialogId.val() +"\""+" >"+ writeOptionPointTypeVal +" </div> " +
        "<div class=\"modbus-comp-table-cell\" data="+"\""+ writePointAddressVal +"\""+" >"+writePointAddressVal+" </div> "+
        "<div class=\"modbus-comp-table-cell\" data="+"\""+ significantChangeVal +"\""+" >"+ significantChangeVal+" </div> "+
        "<div class=\"modbus-comp-table-cell\" data="+"\""+ writePointDataFormatAddDialogId.val()  +"\""+" >"+optionPointDataFormatVal +" </div> "+  
        "<div class=\"modbus-comp-table-cell\">" + "<input id="+ checkBoxWritePtId +" type=\"checkbox\" />" + " </div> "+
        "</div>";
	   

	    widget.writePointDataList[checkBoxWritePtId] = param;
	    
	    var initializefunction =  function (event) {      	
        	initializeEditDialogForWritePoint(event);
	     };
	     
	    dom.on('click', writePointTableRowIdJq,
	    		widget.writePointDataList[checkBoxWritePtId],
	    		initializefunction);
	    
	    dom.on("mouseover", "#"+checkBoxWritePtId, function () {
	    	dom.off("click", widget.writePointDataList[this.id].rowIdJq);	    	
	    });
	    
	    dom.on("mouseout", "#"+checkBoxWritePtId, function () {
	    	dom.on('click', widget.writePointDataList[this.id].rowIdJq,
	    			widget.writePointDataList[this.id],
		    		initializefunction); 	
	    });
	    
		dom.on("change", "#"+checkBoxWritePtId, widget,function(event){
		    modbusWritePointsConfig.handleSelectAllCheckBoxStatusFromWritePointsTable( "#"+event.currentTarget.id,event.data);
		});
		
		modbusWritePointsConfig.sortWriteTableOnSelectedFilter(widget,ModbusWritePointsConfig.activeFilterWritePts);
		
		setModBusDeviceReadWritePointCount(false,Object.keys(widget.writePointDataList).length);
	    
   }
  
  function  addRowToReadPointTableOnAdd(dlgAddReadPtJq,modbusDeviceReadPtObj,widget){
		//scaling factor
  	  
	  var scalingFactorAddDialogId = getScalingFactorDialogId(dlgAddReadPtJq);
	  var readPointAddressAddDialogId = getReadPointAddressDialogId(dlgAddReadPtJq);
	  var readPointNameAddDialogId = getReadPointNameDialogId(dlgAddReadPtJq);
	  var readPointEventBitMaskingDialogId = getReadPointEventBitMaskingDialogId(dlgAddReadPtJq);
	  var readPointPollTimeDialogId = getReadPtPollTimeDialogId(dlgAddReadPtJq);
	  var readPtOperationModeDialogId = getOperationModeDialogId(dlgAddReadPtJq);
	  
	  var scalingFactorVal = scalingFactorAddDialogId.val();
	  var readPointAddressVal = readPointAddressAddDialogId.val();
	  var readPointNameVal = readPointNameAddDialogId.val();
	  var eventBitMaskingVal = readPointEventBitMaskingDialogId.val();
	  var pollTimeVal = readPointPollTimeDialogId.val();
	  var readPtOperationModeVal = readPtOperationModeDialogId.val();
	  
	  
	  var isErrorDialogShown = modbusReadPointsConfig.showErrorDiaogOnAddEditReadPoint(scalingFactorVal,readPointAddressVal,readPointNameVal,eventBitMaskingVal,pollTimeVal,readPtOperationModeVal);
	  
	  if(true == isErrorDialogShown){
		  return isErrorDialogShown;
	  }

	  
	  //read point type
	  var dom = widget.jq();
	  var readPointTypeAddDialogId = getReadPointTypeOnDialogId(dlgAddReadPtJq);  
	  var readPtTypeOrdinals = modbusDeviceReadPtObj.getReadPointType().$map.$map.valueFacets.$val.get("range").getOrdinals();
	  var readOptionPointTypeVal;
		for (var i=0;i<readPtTypeOrdinals.length;i++){				
			if(readPtTypeOrdinals[i]  == readPointTypeAddDialogId.val() ){
				readOptionPointTypeVal =  modbusDeviceReadPtObj.getReadPointType().$map.$map.valueFacets.$val.get("range").getTag(readPtTypeOrdinals[i]);
				break;
			}
		}
	  
		//read point OperationMode
	  
	  var readPointOperationModeAddDialogId =  getOperationModeDialogId(dlgAddReadPtJq);

		for (var j=0;j<widget.readPtOperationModeOrdinals.length;j++){
			if(widget.readPtOperationModeOrdinals[j]  == readPointOperationModeAddDialogId.val() ){
				readPtOperationModeVal = widget.readPtOperationModeRange.getTag(widget.readPtOperationModeOrdinals[j]);
				break;
			}
		}
	    
		//read point data format
	  var readPointDataFormatAddDialogId = getDataFormatDialogId(dlgAddReadPtJq);
	  var optionPointDataFormatVal;

	 var readPtDataFormatOrdinals = modbusDeviceReadPtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getOrdinals();
		for (var k=0;k<readPtDataFormatOrdinals.length;k++){						
				if(readPtDataFormatOrdinals[k]  == readPointDataFormatAddDialogId.val() ){
					optionPointDataFormatVal =  modbusDeviceReadPtObj.getDataFormat().$map.$map.valueFacets.$val.get("range").getTag(readPtDataFormatOrdinals[k]);
					break;
				}
		}	  
	
		var tableBody = getReadPointTableFromDocument();
		var keyListChkBox=  Object.keys(widget.readPointDataList);
		var count = 0,
		readPointTableRowId,
		checkBoxReadPtId;		
		if(keyListChkBox.length > 0){
			//get the last item from keyList
		   var keyChkBoxIdLast = keyListChkBox[keyListChkBox.length-1];
		   count= keyChkBoxIdLast.substring(ModbusUtil.seventeenNumber);
		   count = Number(count)+1;
		 }
			
	  readPointTableRowId = "readPointTableRow"+count;
	  checkBoxReadPtId = "checkBoxReadPoint"+count;
	  
	   var readPtTypeOrdinal = readPointTypeAddDialogId.val(),
       readPtOperationMode = readPointOperationModeAddDialogId.val(),
       readPtDataFormat = readPointDataFormatAddDialogId.val(),
       readPointTableRowIdJq = "#"+readPointTableRowId;

	    var param = {
		    	mainView:widget,
		    	rowIdJq:readPointTableRowIdJq,
		    	readPtName: readPointNameVal,
		    	readPtTypeOrdinal: readPtTypeOrdinal,
		    	readOptionPointTypeVal: readOptionPointTypeVal,
		    	readPtAddress: readPointAddressVal,
		    	readPtOperationMode:readPtOperationMode,
		    	readPtOperationModeVal:readPtOperationModeVal,
		    	readPtPollTime:pollTimeVal,
		    	readPtScalingFactor: scalingFactorVal,
		    	optionPointDataFormatVal:optionPointDataFormatVal,
		    	readPtDataFormat: readPtDataFormat,
		    	oldFb: false,
		    	oldPointName: "",
		    	existingSlotPath: "",
		    	readPtEventBitMasking:eventBitMaskingVal
		     };

	    //if point address and type is same then no need to add in read table
		   var isError = modbusReadPointsConfig.validateReadPtAddressAndType( widget.readPointDataList,param,widget.writePointDataList);
		   if(isError == true){
			   return isError;
		   }
	  
	   tableBody.innerHTML += "<div class=\"md-table-row\" id="+ readPointTableRowId +" onmouseover=\"this.style.background='#E8E8E8';\" onmouseout=\"this.style.background='#ffffff';\">  "   +
         "<div class=\"modbus-comp-table-cell\" title=\""+readPointNameVal+"\" data="+"\""+ readPointNameVal+"\""+" >"+  readPointNameVal+" </div>  "  +
        "<div class=\"modbus-comp-table-cell\" title=\""+readOptionPointTypeVal+"\" data="+"\""+ readPointTypeAddDialogId.val() +"\""+" >"+ readOptionPointTypeVal +" </div> " +
        "<div class=\"modbus-comp-table-cell\" data="+"\""+readPointAddressVal +"\""+" >"+ readPointAddressVal+" </div> "+
        "<div class=\"modbus-comp-table-cell\" data="+"\""+ readPointOperationModeAddDialogId.val()  +"\""+" >"+ readPtOperationModeVal +" </div> "+
        "<div class=\"modbus-comp-table-cell\" data="+"\""+ scalingFactorVal +"\""+" >"+ scalingFactorVal+" </div> "+
        "<div class=\"modbus-comp-table-cell\" data="+"\""+ pollTimeVal +"\""+" >"+ pollTimeVal+" </div> "+
        "<div class=\"modbus-comp-table-cell\" data="+"\""+ readPointDataFormatAddDialogId.val()  +"\""+" >"+optionPointDataFormatVal +" </div> "+  
        "<div class=\"modbus-comp-table-cell\" data="+"\""+ eventBitMaskingVal  +"\""+" >"+modbusUtil.showInHex(eventBitMaskingVal) +" </div> "+  
        "<div class=\"modbus-comp-table-cell\">" + "<input id="+ checkBoxReadPtId +" type=\"checkbox\" />" + " </div> "+
        "</div>";

	    widget.readPointDataList[checkBoxReadPtId] = param;
	    
	    modbusReadPointsConfig.sortReadTableOnSelectedFilter(widget,ModbusReadPointsConfig.activeFilterReadPts);
	    
	    
	    var initializefunction =  function (event) {      	
        	initializeEditDialogForReadPoint(event);
	     };
	     
	    dom.on('click', readPointTableRowIdJq,
	    		param,
	    		initializefunction);
	    
	    dom.on("mouseover", "#"+checkBoxReadPtId, function () {
	    	dom.off("click", widget.readPointDataList[this.id].rowIdJq);	    	
	    });
	    
	    dom.on("mouseout", "#"+checkBoxReadPtId, function () {
	    	dom.on('click', widget.readPointDataList[this.id].rowIdJq,
	    			widget.readPointDataList[this.id],
		    		initializefunction); 	
	    });
	    
		dom.on("change", "#"+checkBoxReadPtId,widget, function(event){
			modbusReadPointsConfig.handleSelectAllCheckBoxStatusFromReadPointsTable( "#"+event.currentTarget.id,event.data);
		});  
		
		setModBusDeviceReadWritePointCount(true,Object.keys(widget.readPointDataList).length);
	    
   }
	     
  function loadModbusReadPointsContent(modbusDevice, dom){
	  
	  var modbusServerSideclassName = "honIrmControl:ModbusServerSideCallHandler";
	  var getModbusReadPointFunc  = "getReadPointsFromModbusDevice";

	  return modbusDevice.serverSideCall({
		  typeSpec:   modbusServerSideclassName,
		  methodName: getModbusReadPointFunc
	   })
	  	.then(function(modbusReadInputsResult) {
	  		populateModbusReadPointsTable(dom,modbusReadInputsResult)

	  	})
     .catch(function(err) {
       return Promise.reject(err);
     });

  }
  
  function loadModbusWritePointsContent(modbusDevice, dom){
	  
	  var modbusServerSideclassName = "honIrmControl:ModbusServerSideCallHandler";
	  var getModbusOutputFunction  = "getWritePointsFromModbusDevice";

	  return modbusDevice.serverSideCall({
		  typeSpec:   modbusServerSideclassName,
		  methodName: getModbusOutputFunction
	   })
	  	.then(function(modbusWriteOutputsResult) {	
	  		populateModbusWritePointsTable(dom,modbusWriteOutputsResult)

	  	})
     .catch(function(err) {
       return Promise.reject(err);
     });

  }


  function showErrorDiaogOnEditOfModbusDevice(devAddressVal,modDevInputCount,isAddressExistsCheck){
	  	  
	  if(isAddressExistsCheck){
		  dialogs.showOk({
			  title: honIrmControlLex.get('honIrmControlLex.modbus.edit.error.title'),
			  content: honIrmControlLex.get('honIrmControlLex.modbus.device.address.exists'),
			  private: false
		     })
			  .ok(function () {
			    return true;
			  });
		 return true;
	  }
	  
	  var devAddressEmpty =  modbusUtil.checkStirngAsNullOrEmpty(devAddressVal);
	  var modDevInputEmpty =  modbusUtil.checkStirngAsNullOrEmpty(modDevInputCount)
	  if(devAddressEmpty == true || modDevInputEmpty == true){
		  dialogs.showOk({
			  title: honIrmControlLex.get('honIrmControlLex.modbus.edit.error.title'),
			  content: honIrmControlLex.get('honIrmControlLex.modbus.edit.error.empty'),
			  private: false
		     })
			  .ok(function () {
			    return true;
			  });
		 return true;
	  }
	  if(devAddressVal <1 || devAddressVal > 247){
		  dialogs.showOk({
				  title: honIrmControlLex.get('honIrmControlLex.modbus.edit.error.title '),
				  content: honIrmControlLex.get('honIrmControlLex.modbus.edit.deviceAddress.error'),
				  private: false
			     })
				  .ok(function () {
				    return true;
				  });
			 return true;  
	  }
	  
	  if(modDevInputCount <1 || modDevInputCount > 20 ){
		  dialogs.showOk({
				  title: honIrmControlLex.get(' honIrmControlLex.modbus.edit.error.title '),
				  content: honIrmControlLex.get('honIrmControlLex.modbus.edit.maxReadCount.error'),
				  private: false
			      })
				  .ok( function () {
				    return true;
				  });
			 return true;
	  }
	  
  }  
	  /**.
	   *
	   * Note that the parameter to this function is the same as that resolved by
	   * doRead().
	   *
	   * @returns {Promise}
	   */
	  ModbusDeviceConfigView.prototype.doSave = function (readValue) { //-------------- *NEW*
		  var widget = this,
		  isAddressExistsCheck = false,
		  dom = widget.jq();
		  
		  var isErrorOnModbus = showErrorDiaogOnEditOfModbusDevice(getModBusDeviceAddress().val(),getModBusDevicePointCount().val(),isAddressExistsCheck);
		  if(isErrorOnModbus == true){
			  return;
		  }
		 saveModbusOverviewContent(readValue,dom, widget);

	  };
	  
	  /**
	   * 
	   */
	  function saveModbusOverviewContent(modbusDevice,dom, widget){
		   var modbusServerSideclassName = "honIrmControl:ModbusServerSideCallHandler";
		   var saveModbusPropFunction  = "saveModbusDeviceProperties";
		   var validateModbusPropFunction  = "validateModbusFunctionBlock";
		    	      
		   var modbusDeviceArgsObj = baja.$('honIrmControl:ModbusDeviceArgs');
		   modbusDeviceArgsObj.add({
			    slot: "DeviceAddress",
			    value: getModBusDeviceAddress().val()
			  });
		   modbusDeviceArgsObj.add({
			    slot: "ByteOrder",
			    value: getModBusDeviceByteOrder().val()
		   });
		   modbusDeviceArgsObj.add({
				slot: "MaxReadPointCount",
				value: getModBusDevicePointCount().val()
		   });
		   
	         //if modbusdevice property is saved then only read and write pts properties should be saved.	
	   		var readPointData = modbusReadPointsConfig.getModbusReadPointTableData(dom, widget);
	   		// readPointData is true means error has been shown so do not proceed
	   		if(readPointData == true){
	   			return;
	   		}
	   	   // writePointData is true means error has been shown so do not proceed
	   		var writePointData = modbusWritePointsConfig.getModbusWritePointTableData(dom, widget);
	   		if(writePointData == true){
	   			return;
	   		}
	   		
	   		//get the deleted read pt list
	         //if modbusdevice property is saved then only read and write pts properties should be saved.	
	   		var deletedReadPointData = modbusReadPointsConfig.getModbusDeletedReadPointTableData(widget);

	   	   // writePointData is true means error has been shown so do not proceed
	   		var  deletedWritePointData = modbusWritePointsConfig.getModbusDeleteWritePointTableData(widget);

	   		modbusDeviceArgsObj.add({
				slot: "readPointList",
				value: readPointData
		   });
	   		
	   		modbusDeviceArgsObj.add({
				slot: "writePointList",
				value: writePointData
		   });
	   		
	   		if(deletedReadPointData.$map.$array.length > 0){
	   			modbusDeviceArgsObj.add({
	   				slot: "deleteReadPointList",
	   				value: deletedReadPointData
	   			});
	   		}
	   		if(deletedWritePointData.$map.$array.length > 0){
	   			modbusDeviceArgsObj.add({
	   				slot: "deleteWritePointList",
	   				value: deletedWritePointData
	   			});
	   		}
		   
		   return modbusDevice.serverSideCall({
		     typeSpec:   modbusServerSideclassName,
		     methodName: validateModbusPropFunction,
		     value:      modbusDeviceArgsObj
		     
		   })
		   .then(function(resultObject) {	
			    // modbusDevice address exists
		        if (resultObject == true) {	
		  		  var isErrorOnModbus = showErrorDiaogOnEditOfModbusDevice(getModBusDeviceAddress().val(),getModBusDevicePointCount().val(),true);
		  		  	if(isErrorOnModbus == true){
					  return;
				  	}
		        }
		        else{
		 		   return modbusDevice.serverSideCall({
		 			     typeSpec:   modbusServerSideclassName,
		 			     methodName: saveModbusPropFunction,
		 			     value:      modbusDeviceArgsObj		 			     
		 			})
		 	    // --------
		 		.then(function(resultObject) {	
		        if (resultObject == true) {
		        	
		        	 return Promise.resolve(true);
		        }
		     })

		   }
		 })
		.catch(function(err) {
		       return Promise.reject(err);
		  });	  
	  }
	    
  return ModbusDeviceConfigView;
});

/* START_TEMPLATE */
define('hbs!nmodule/honIrmControl/rc/templates/powerUpDelay',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    return "<div>\n<div style=\"padding-bottom:6px;\">\n<label id=\"powerUpDelaySelectLblId\" style=\"padding-right:8px;\">Power Up Behaviour:</label>\n<select id=\"powerUpDelaySelectId\"></select>  \n</div>\n<div>\n<label id=\"powerUpDelayTxtLblId\">Power Up Delay Time:</label>\n<input id=\"powerUpDelayTxtId\" type=\"number\" value=\"\" />\n<label id=\"powerUpDelayTxtUnitLblId\">(1-4095) s</label>\n</div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/honIrmControl/rc/templates/powerUpDelay', t);
return t;
});
/* END_TEMPLATE */
;
/*
Copyright (c) 2021 Honeywell International, Inc. All rights reserved.
This file contains trade secrets of Honeywell International, Inc. No part
may be reproduced or transmitted in any form by any means or for any
purpose without the express written permission of Honeywell.
*/
/**
  * Builds a javascript widget that builds property sheet for Power Up Delay slot of Floating Block
  * @E579516
  */
define('nmodule/honIrmControl/rc/functionblocks/PowerUpDelayWidget',['baja!',
  'nmodule/webEditors/rc/fe/baja/BaseEditor',
  'baja!honIrmControl:PowerUPDelayEnum',
  'bajaux/mixin/subscriberMixIn',
  'jquery',
  'dialogs',
  'Promise',
  'bajaux/util/SaveCommand',
  'hbs!nmodule/honIrmControl/rc/templates/powerUpDelay',
  'lex!honIrmControl'],
  function (      //NOSONAR
    baja,
    BaseEditor,
    PowerUPDelayEnum,
    subscriberMixin,
    $,
    dialogs,
    Promise,     //NOSONAR
    SaveCommand,
    template,
    lex) {
	
	
	
	var honIrmControlLex = lex[0];
	
	
	function getPowerUpDelaySelect(dom) {									
		return dom.find('#powerUpDelaySelectId');
	}
    
	function getPowerUpDelayTxt(dom) {									
		return  dom.find('#powerUpDelayTxtId');
	}
	
	function getPowerUpDelayTxtLbl(dom) {									
		return dom.find('#powerUpDelayTxtLblId');
	}
	
	
	function getPowerUpDelayTxtUnitLbl(dom) {									
		return dom.find('#powerUpDelayTxtUnitLblId');
	}
	

	

    /**
    * An editor which helps in editing value
    */
    var PowerUpDelayWidget = function () {   //NOSONAR
      BaseEditor.apply(this, arguments);
    	//BaseEditor.make(this,arguments);
      subscriberMixin(this);
      this.getCommandGroup().add(new SaveCommand());
      this.powerUpDelayOptionsObjs = baja.$('honIrmControl:PowerUPDelayEnum');
      this.NoPowerUpDelay = this.powerUpDelayOptionsObjs.getEnum().getRange().getOrdinals()[0];
      this.WaitAccordingToTheSelectedPowerUpDelay = this.powerUpDelayOptionsObjs.getEnum().getRange().getOrdinals()[1];
      this.MoveToClosedAfterPowerUpWithoutWaiting = this.powerUpDelayOptionsObjs.getEnum().getRange().getOrdinals()[2];
      this.MoveToOpenAfterPowerUpWithoutWaiting = this.powerUpDelayOptionsObjs.getEnum().getRange().getOrdinals()[3];
      this.SynchronizeRandomlyToClosedOrOpenWithoutWaiting = this.powerUpDelayOptionsObjs.getEnum().getRange().getOrdinals()[4];
      this.powerUpDelayMaxVal =4095; 
      this.powerUpDelayMinVal =1; 
    };

    //extend and set up prototype chain
    PowerUpDelayWidget.prototype = Object.create(BaseEditor.prototype);
    PowerUpDelayWidget.prototype.constructor = PowerUpDelayWidget;

    /**
    * Do initial setup of the DOM for the widget. This will set up the DOM's
    * structure and create a space where the editors would go.
    *
    * @param {jQuery} element the DOM element into which to load this widget
    */
    PowerUpDelayWidget.prototype.doInitialize = function (dom) {
      BaseEditor.prototype.doInitialize.call(this, dom);
      var that = this;     
      dom.html(template({
    	  
      }));  
       
      dom.find('select').on('change', function () {
          that.setModified(true);
        });  
      dom.find('input').on('change', function () {
          that.setModified(true);
        });
    };
    
    /**
    * Load the component
    */
    PowerUpDelayWidget.prototype.doLoad = function (comp) {
  	 var widget = this;
  	 var dom = widget.jq();
 	 loadPowerUpDelayContent(comp, widget);
	 dom.on("change", "#powerUpDelaySelectId",widget,function(event){
		     event.preventDefault();
		     changeVisibilityOfPowerUpDelayTextField(widget);
		});
	 dom.on("change", "#powerUpDelayTxtId",widget,function(event){
	     event.preventDefault();
	     var isErrorDialogShown = showErrorOnPowerUpDelayValidation(widget);
	     if(true == isErrorDialogShown){
	    	 getPowerUpDelayTxt(dom).val(Number(widget.powerUpDelayMaxVal));
	     }
	     
	});
    };
    
    
    
   function showErrorOnPowerUpDelayValidation(widget){ 
	var dom = widget.jq();
    var powerUpDelayOption = getPowerUpDelaySelect(dom).val();
    if(powerUpDelayOption == widget.WaitAccordingToTheSelectedPowerUpDelay){
   	 var powerUpDelayOptionValueEntered = getPowerUpDelayTxt(dom).val();
		  if(powerUpDelayOptionValueEntered > widget.powerUpDelayMaxVal || powerUpDelayOptionValueEntered < widget.powerUpDelayMinVal ){
				 dialogs.showOk({
					  title: honIrmControlLex.get('honIrmControlLex.floating.error.title'),
					  content: honIrmControlLex.get('honIrmControlLex.power.up.delay.limit.error'),
					  private: false
				     })
					  .ok(function () {
					    return true;
					  });
					
				 return true;
			  
		  }
     }
    }
    
    function changeVisibilityOfPowerUpDelayTextField(widget){ 
    	 var dom = widget.jq();
	     var powerUpDelayOption = getPowerUpDelaySelect(dom).val();
	     if(powerUpDelayOption != widget.WaitAccordingToTheSelectedPowerUpDelay){
	    	 getPowerUpDelayTxt(dom).hide();
	    	 getPowerUpDelayTxtLbl(dom).hide();
	    	 getPowerUpDelayTxtUnitLbl(dom).hide();
	    	 if(powerUpDelayOption == widget.NoPowerUpDelay ){
	    	 getPowerUpDelayTxt(dom).val(Number(widget.NoPowerUpDelay)); 
	    	 }else if(powerUpDelayOption == widget.MoveToClosedAfterPowerUpWithoutWaiting ){
	    		getPowerUpDelayTxt(dom).val(Number(widget.MoveToClosedAfterPowerUpWithoutWaiting));  
	    	 }else if(powerUpDelayOption == widget.MoveToOpenAfterPowerUpWithoutWaiting ){
	    		 getPowerUpDelayTxt(dom).val(Number(widget.MoveToOpenAfterPowerUpWithoutWaiting)); 
	    	 }else{
	    		 getPowerUpDelayTxt(dom).val(Number(widget.SynchronizeRandomlyToClosedOrOpenWithoutWaiting)); 
	    	 }
	    	 
	     }else{
	    	 getPowerUpDelayTxt(dom).val(Number(widget.powerUpDelayMaxVal));
	    	 getPowerUpDelayTxt(dom).show();
	    	 getPowerUpDelayTxtLbl(dom).show();
	    	 getPowerUpDelayTxtUnitLbl(dom).show();
	     }
    }
    
    function loadPowerUpDelayContent(component, widget){
    	widget.getComplex().getParent().rpc("getPowerUpDelayValues").then(function(value) {
    		if(value !== undefined){
    			 var dom = widget.jq();
    			var jsonObj = JSON.parse(value);
    			 var powerUpDelayEnum = jsonObj.powerUpDelayEnum,
    			 powerUpDelayValue = jsonObj.powerUpDelayValue

    			 var powerUpDelayOptionsObj1s = baja.$('honIrmControl:PowerUPDelayEnum');
    			 var powerUpDelayOptionOrdinal = powerUpDelayOptionsObj1s.getEnum().getRange().getOrdinals();
    				var option = '';
    				$("#powerUpDelaySelectId option").remove();
    				for (var i=0;i<powerUpDelayOptionOrdinal.length;i++){
    					var powerUpDelayOption =  powerUpDelayOptionsObj1s.getEnum().getRange().getDisplayTag(powerUpDelayOptionOrdinal[i]);
    					option += '<option value="'+ powerUpDelayOptionOrdinal[i] + '">' + powerUpDelayOption + '</option>';
    				}
    				getPowerUpDelaySelect(dom).append(option);
    				getPowerUpDelaySelect(dom).val(powerUpDelayEnum.toString());
    				getPowerUpDelayTxt(dom).val(Number(powerUpDelayValue));
    			     if(powerUpDelayEnum != widget.WaitAccordingToTheSelectedPowerUpDelay){
    			    	 getPowerUpDelayTxt(dom).hide();
    			    	 getPowerUpDelayTxtLbl(dom).hide();
    			    	 getPowerUpDelayTxtUnitLbl(dom).hide();
    			     }else{
    			    	 getPowerUpDelayTxt(dom).show();
    			    	 getPowerUpDelayTxtLbl(dom).show();
    			    	 getPowerUpDelayTxtUnitLbl(dom).show();
    			     }
    		}        	    	
        });
    }
    
    /**
     * Detach the event handlers when destroying the widget.
     */
    PowerUpDelayWidget.prototype.doDestroy = function () {
      this.jq().find('input').off();
      this.jq().find('select').off();
    };

    /**
     * Save the user-entered changes to the loaded component.
     *
     * Note that the parameter to this function is the same as that resolved by
     * doRead().
     *
     */
    PowerUpDelayWidget.prototype.doSave = function (readValue, params) {
     	 var widget = this;
      	 savePowerUpDelayContent(readValue, widget);
     };
       
     function savePowerUpDelayContent(component, widget){
    	 var dom = widget.jq();
    	 var powerUpDelay = { powerUpDelayValue: getPowerUpDelayTxt(dom).val()};
    	 var powerUpDelayJSON = JSON.stringify(powerUpDelay);
       widget.getComplex().getParent().rpc("setPowerUpDelayValues",powerUpDelayJSON).then(function(value){     	    	
          });
      }
    return PowerUpDelayWidget;
  });

/* START_TEMPLATE */
define('hbs!nmodule/honIrmControl/rc/templates/autoSynchInterval',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    return "<div>\n<div style=\"padding-bottom:6px;\">\n<label id=\"autoSynchIntevalSelectLblId\" style=\"padding-right:8px;\">Time-based repeated Synch:</label>\n<select id=\"autoSynchIntevalSelectId\"></select>  \n</div>\n<div>\n<label id=\"autoSynchIntevalTxtLblId\">Auto Synch Interval:</label>\n<input id=\"autoSynchIntevalTxtId\" type=\"number\" value=\"\" />\n<label id=\"autoSynchIntevalTxtUnitLblId\">(1-255) hr</label>\n</div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/honIrmControl/rc/templates/autoSynchInterval', t);
return t;
});
/* END_TEMPLATE */
;
/*
Copyright (c) 2021 Honeywell International, Inc. All rights reserved.
This file contains trade secrets of Honeywell International, Inc. No part
may be reproduced or transmitted in any form by any means or for any
purpose without the express written permission of Honeywell.
*/
/**
  * Builds a javascript widget that builds property sheet for Auto Synch inteval slot of Floating Block
  * @E579516
  */
define('nmodule/honIrmControl/rc/functionblocks/AutoSynchIntervalWidget',['baja!',
  'nmodule/webEditors/rc/fe/baja/BaseEditor', 
  'baja!honIrmControl:AutoSyncIntervalEnum',
  'bajaux/mixin/subscriberMixIn',
  'jquery',
  'dialogs',
  'Promise',
  'bajaux/util/SaveCommand',
  'hbs!nmodule/honIrmControl/rc/templates/autoSynchInterval',
  'lex!honIrmControl'],
  function (      //NOSONAR
    baja,
    BaseEditor,
    AutoSyncIntervalEnum,
    subscriberMixin,
    $,
    dialogs,
    Promise,     //NOSONAR
    SaveCommand,
    template,
    lex) {
	
	
	
	var honIrmControlLex = lex[0];
	
	
	function getAutoSynchIntevalSelect(dom) {									
		return dom.find('#autoSynchIntevalSelectId');
	}
    
	function getAutoSynchIntevalTxt(dom) {									
		return  dom.find('#autoSynchIntevalTxtId');
	}
	
	function getAutoSynchIntevalTxtLbl(dom) {									
		return dom.find('#autoSynchIntevalTxtLblId');
	}
	
	function getAutoSynchIntevalTxtUnitLbl(dom) {									
		return dom.find('#autoSynchIntevalTxtUnitLblId');
	}
	
    /**
    * An editor which helps in editing value
    */
    var AutoSynchIntervalWidget = function () {   //NOSONAR
      BaseEditor.apply(this, arguments);
    	//BaseEditor.make(this,arguments);
      subscriberMixin(this);
      this.getCommandGroup().add(new SaveCommand());
      this.autoSyncIntervalOptionsObjs = baja.$('honIrmControl:AutoSyncIntervalEnum');
      this.NoTimeBasedRepeatedSynchronization = this.autoSyncIntervalOptionsObjs.getEnum().getRange().getOrdinals()[0];
      this.ToClosedOrOpenDependingOnSynchOperation = this.autoSyncIntervalOptionsObjs.getEnum().getRange().getOrdinals()[1];
      this.ToClosedIndependentOfSynchOperation = this.autoSyncIntervalOptionsObjs.getEnum().getRange().getOrdinals()[2];
      this.ToOpenIndependentOfSynchOperation = this.autoSyncIntervalOptionsObjs.getEnum().getRange().getOrdinals()[3];
      this.ToClosedAfter24hRandomly = this.autoSyncIntervalOptionsObjs.getEnum().getRange().getOrdinals()[4];
      this.ToOpenAfter24hRandomly = this.autoSyncIntervalOptionsObjs.getEnum().getRange().getOrdinals()[5];
      this.autoSyncIntervalMaxVal =255; 
      this.autoSyncIntervalMinVal =1; 
    };

    //extend and set up prototype chain
    AutoSynchIntervalWidget.prototype = Object.create(BaseEditor.prototype);
    AutoSynchIntervalWidget.prototype.constructor = AutoSynchIntervalWidget;

    /**
    * Do initial setup of the DOM for the widget. This will set up the DOM's
    * structure and create a space where the editors would go.
    *
    * @param {jQuery} element the DOM element into which to load this widget
    */
    AutoSynchIntervalWidget.prototype.doInitialize = function (dom) {
      BaseEditor.prototype.doInitialize.call(this, dom);
      var that = this;     
      dom.html(template({
    	  
      }));  
       
      dom.find('select').on('change', function () {
          that.setModified(true);
        });  
      dom.find('input').on('change', function () {
          that.setModified(true);
        });
    };
    
    /**
    * Load the component
    */
    AutoSynchIntervalWidget.prototype.doLoad = function (comp) {
  	 var widget = this;
  	 var dom = widget.jq();
 	 loadAutoSynchIntevalContent(comp, widget);
	 dom.on("change", "#autoSynchIntevalSelectId",widget,function(event){
		     event.preventDefault();
		     changeVisibilityOfAutoSynchIntevalTextField(widget);
		});
	 dom.on("change", "#autoSynchIntevalTxtId",widget,function(event){
	     event.preventDefault();
	     var isErrorDialogShown = showErrorOnAutoSynchIntevalValidation(widget);
	     if(true == isErrorDialogShown){
	    	 getAutoSynchIntevalTxt(dom).val(Number(widget.autoSyncIntervalMaxVal));
	     }
	     
	});
    };
    
    
    
   function showErrorOnAutoSynchIntevalValidation(widget){  
	var dom = widget.jq();
    var autoSynchIntevalOption = getAutoSynchIntevalSelect(dom).val();
    if(autoSynchIntevalOption == widget.ToClosedOrOpenDependingOnSynchOperation
    		|| autoSynchIntevalOption == widget.ToClosedIndependentOfSynchOperation
    		|| autoSynchIntevalOption == widget.ToOpenIndependentOfSynchOperation){
   	 var autoSynchIntevalOptionValueEntered = getAutoSynchIntevalTxt(dom).val();
		  if(autoSynchIntevalOptionValueEntered > widget.autoSyncIntervalMaxVal || autoSynchIntevalOptionValueEntered < widget.autoSyncIntervalMinVal ){
				 dialogs.showOk({
					  title: honIrmControlLex.get('honIrmControlLex.floating.error.title'),
					  content: honIrmControlLex.get('honIrmControlLex.auto.synch.inteval.limit.error'),
					  private: false
				     })
					  .ok(function () {
					    return true;
					  });
					
				 return true;
			  
		  }
     }
    }
    
    function changeVisibilityOfAutoSynchIntevalTextField(widget){
    	 var dom = widget.jq();
	     var autoSynchIntevalOption = getAutoSynchIntevalSelect(dom).val();
	     if(autoSynchIntevalOption == widget.NoTimeBasedRepeatedSynchronization
	    		 || autoSynchIntevalOption == widget.ToClosedAfter24hRandomly
	    		 || autoSynchIntevalOption == widget.ToOpenAfter24hRandomly ){
	    	 getAutoSynchIntevalTxt(dom).hide();
	    	 getAutoSynchIntevalTxtLbl(dom).hide();
	    	 getAutoSynchIntevalTxtUnitLbl(dom).hide();
	    	 if(autoSynchIntevalOption == widget.NoTimeBasedRepeatedSynchronization ){
	    		 getAutoSynchIntevalTxt(dom).val(Number(widget.NoTimeBasedRepeatedSynchronization)); 
	    	 }else if(autoSynchIntevalOption == widget.ToClosedAfter24hRandomly ){
	    		 getAutoSynchIntevalTxt(dom).val(Number(widget.ToClosedAfter24hRandomly));  
	    	 }else if(autoSynchIntevalOption == widget.ToOpenAfter24hRandomly ){
	    		 getAutoSynchIntevalTxt(dom).val(Number(widget.ToOpenAfter24hRandomly)); 
	    	 }
	    	 
	     }else{
	    	 getAutoSynchIntevalTxt(dom).val(Number(widget.autoSyncIntervalMaxVal));
	    	 getAutoSynchIntevalTxt(dom).show();
	    	 getAutoSynchIntevalTxtLbl(dom).show();
	    	 getAutoSynchIntevalTxtUnitLbl(dom).show();
	     }
    }
    
    function loadAutoSynchIntevalContent(component, widget){
    	var jsonObj = null;
    	widget.getComplex().getParent().rpc("getAutoSynchIntevalValues").then(function(value) {
    		if(value !== undefined){
    			 var dom = widget.jq();
    			jsonObj = JSON.parse(value);
    			 var autoSynchIntervalEnum = jsonObj.autoSynchIntervalEnum,
    			 autoSynchIntervalValue = jsonObj.autoSynchIntervalValue;
    			 var autoSyncIntervalOptionsObjs1 = baja.$('honIrmControl:AutoSyncIntervalEnum');
    			 var autoSyncIntervalOptionOrdinal = autoSyncIntervalOptionsObjs1.getEnum().getRange().getOrdinals();
    				var option = '';
    				$("#autoSynchIntevalSelectId option").remove();
    				for (var i=0;i<autoSyncIntervalOptionOrdinal.length;i++){
    					var autoSyncIntervalOption =  autoSyncIntervalOptionsObjs1.getEnum().getRange().getDisplayTag(autoSyncIntervalOptionOrdinal[i]);
    					option += '<option value="'+ autoSyncIntervalOptionOrdinal[i] + '">' + autoSyncIntervalOption + '</option>';
    				}
    				getAutoSynchIntevalSelect(dom).append(option);
    				getAutoSynchIntevalSelect(dom).val(autoSynchIntervalEnum.toString());
    				getAutoSynchIntevalTxt(dom).val(Number(autoSynchIntervalValue));
    			     if(autoSynchIntervalEnum == widget.NoTimeBasedRepeatedSynchronization
    			    		 || autoSynchIntervalEnum == widget.ToClosedAfter24hRandomly
    			    		 || autoSynchIntervalEnum == widget.ToOpenAfter24hRandomly ){
    			    	 getAutoSynchIntevalTxt(dom).hide();
    			    	 getAutoSynchIntevalTxtLbl(dom).hide();
    			    	 getAutoSynchIntevalTxtUnitLbl(dom).hide();
    			     }else{
    			    	 getAutoSynchIntevalTxt(dom).show();
    			    	 getAutoSynchIntevalTxtLbl(dom).show();
    			    	 getAutoSynchIntevalTxtUnitLbl(dom).show();
    			     }
    		}        	    	
        });
    	
    }
    
    /**
     * Detach the event handlers when destroying the widget.
     */
    AutoSynchIntervalWidget.prototype.doDestroy = function () {
      this.jq().find('input').off();
      this.jq().find('select').off();
    };

    /**
     * Save the user-entered changes to the loaded component.
     *
     * Note that the parameter to this function is the same as that resolved by
     * doRead().
     *
     */
    AutoSynchIntervalWidget.prototype.doSave = function (readValue, params) {
     	 var widget = this;
      	 saveAutoSynchIntervalContent(readValue, widget);
     };
       
     function saveAutoSynchIntervalContent(component, widget){
    	 var dom = widget.jq();
    	 var autoSynchInteval = { autoSynchIntervalEnum: getAutoSynchIntevalSelect(dom).val(),autoSynchIntervalValue: getAutoSynchIntevalTxt(dom).val()};
    	 var autoSynchIntevalJSON = JSON.stringify(autoSynchInteval);
       widget.getComplex().getParent().rpc("setAutoSynchIntevalValues",autoSynchIntevalJSON).then(function(value){     	    	
          });
      }
    return AutoSynchIntervalWidget;
  });


require(['nmodule/honIrmControl/rc/ModbusDeviceConfigView',
	     'nmodule/honIrmControl/rc/functionblocks/PowerUpDelayWidget',
	     'nmodule/honIrmControl/rc/functionblocks/AutoSynchIntervalWidget'], function (ModbusDeviceConfigView,PowerUpDelayWidget,AutoSynchIntervalWidget) {
  
});


define("nmodule/honIrmControl/rc/honIrmControl.run", function(){});
